Deleted Added
full compact
Makefile (156813) Makefile (156854)
1# $FreeBSD: head/release/Makefile 156813 2006-03-17 18:54:44Z ru $
1# $FreeBSD: head/release/Makefile 156854 2006-03-18 21:37:05Z ru $
2#
3# make release [BUILDNAME=somename] CHROOTDIR=/some/dir CVSROOT=/cvs/dir \
4# [RELEASETAG=tag]
5#
6# Where "/some/dir" is the pathname of a directory on a some filesystem with
7# at least 1000MB of free space, "somename" is what you want the release to
8# call itself, "/cvs/dir" is where our source repo resides and, optionally,
9# which CVS "tag" name should be used when checking out the sources to build
10# the release (default is HEAD).
11#
12# Please note: the md(4) driver must be present in the kernel
13# (either by being compiled in or available as a kld(4) module),
14# otherwise the target 'release.8' and possibly others will fail.
15#
16# Note: If you add options to this file, please keep release(7) updated!
17#
18# Set these, release builder!
19#
20# Fixed version:
21#BUILDNAME=7.0-CURRENT
22#
23# Automatic SNAP versioning:
24DATE != date +%Y%m%d
25BASE = 7.0
26BUILDNAME?=${BASE}-${DATE}-SNAP
27#
28#CHROOTDIR=/junk/release
29# If this is a -stable snapshot, then set
30#RELEASETAG=RELENG_6
31#
32# To test a release with a source tree containing patches and
33# other work. This tree will get copied instead of getting the
34# src/ tree from a CVS checkout. For "rerelease", this will NOT
35# be copied; cvs update will be used instead.
36#EXTSRCDIR=/usr/src
37#
38# To use a checked-out ports collection directory instead of
39# checking out from a local CVS repository, set this option.
40#EXTPORTSDIR=/usr/ports
41#
42# To add other options to the CVS subcommands (co,up), set
43#CVSCMDARGS="-D '01/01/2002 00:00:00 UTC'"
44#
45# To add other options to the CVS command, set
46#CVSARGS="-lfq"
47#
48# To prefix the cvs command
49#CVSPREFIX="/usr/bin/time"
50#
51# Where the CVS repository is
52#CVSROOT="/home/ncvs"
53#
54# Non-zero if ${RELEASETAG} is in the form "RELENG_ver_RELEASE"; we
55# are building an official release. Otherwise, we are building for
56# a branch.
57.if defined(RELEASETAG)
58ISRELEASE!= expr "${RELEASETAG}" : '^RELENG_.*_RELEASE$$' || true
59.if ${ISRELEASE} != 0
60# Convert "RELENG_ver_RELEASE" to "RELEASE_ver" for ports and doc trees.
61AUXRELEASETAG!= echo ${RELEASETAG} | sed -e 's/^RELENG_/RELEASE_/' -e 's/_RELEASE$$//'
62DOCRELEASETAG?= ${AUXRELEASETAG}
63PORTSRELEASETAG?= ${AUXRELEASETAG}
64.endif
65.endif
66
67# If you want to pass flags to the world build such as -j X, use
68# WORLD_FLAGS. Similarly, you can specify make flags for kernel
69# builds via KERNEL_FLAGS.
70#WORLD_FLAGS=-j4
71#KERNEL_FLAGS=-j4
72
73TARGET_ARCH?= ${MACHINE_ARCH}
74.if ${TARGET_ARCH} == ${MACHINE_ARCH}
75TARGET?= ${MACHINE}
76.else
77TARGET?= ${TARGET_ARCH}
78.endif
79CROSSENV= TARGET_ARCH=${TARGET_ARCH} TARGET=${TARGET}
80CROSSMAKE= ${MAKE} ${CROSSENV}
81NATIVEMAKE= ${MAKE} TARGET_ARCH=${MACHINE_ARCH} TARGET=${MACHINE}
82
83# If you are using a local CVS repository with components stored in
84# non-standard modules, override these on the make commandline or
85# in the environment.
86RELEASESRCMODULE?= src
87RELEASEDOCMODULE?= doc
88RELEASEPORTSMODULE?= ports
89
90# Uncomment this to disable the doc.1 target. Docs normally require
91# the ports tree, so NOPORTS can be set together with NODOC in order
92# to have neither ports or docs. If only NOPORTS is set to YES, but
93# docs are still desired, the DOMINIMALDOCPORTS logic below will only
94# install the ports that are minimally required for the docs. This is
95# intended as a compromise, less disk space is required than for using
96# the entire ports collection (and much less time due to the huge number
97# of directories it would create), but still quite a bit as well as some
98# CPU cycles (some of the programs are C++, and things like ghostscript
99# belong to the required ports nevertheless).
100#
101# Setting this also disables building of release note documentation
102# (RELNOTESng).
103#NODOC= YES
104#NOPORTS= YES
105
106# When retrieving ports using the pkg_add -r method, set your proxies to these.
107# src/release/${arch}/mkisoimages.sh can use these.
108#HTTP_PROXY?= www.example.com
109#FTP_PROXY?= ftp.example.com
110
111# When creating ISO images, point ${CD_PACKAGE_TREE} to a directory containing
112# the package split by an earlier invocation of the 'package-split' target.
113#CD_PACKAGE_TREE= /path/to/pkg
114
115# Extra source tarballs; each argument is a pair of source dir and
116# distribution name. The dist name should not exceed 7 characters
117# (another "s" for "source" will be prepended).
118#EXTRA_SRC= games/fortune fortune
119
120# Modify this definition if you want the release notes
121# and other release documentation in a language other than English.
122RELNOTES_LANG?= en_US.ISO8859-1
123
124# As an alternative to installing the entire ports collection (which
125# can take a huge amount of time, in particular on slower disks),
126# setting ${MINIMALDOCPORTS} allows to install and build just those
127# ports that are really required for getting the docs up & running.
128.if defined(NOPORTS) && !defined(NODOC)
129DOMINIMALDOCPORTS= YES
130.include "Makefile.inc.docports"
131RELEASEPORTSMODULE= ${MINIMALDOCPORTS}
132.endif
133
134# Helper variable
135.if defined(NOPORTS)
136.if !defined(DOMINIMALDOCPORTS) || ${DOMINIMALDOCPORTS} != "YES"
137NOPORTSATALL= YES
138.endif
139.endif
140
141#
142# Doing 'make index' in /usr/ports requires Perl.
143MAKEINDEXPORTS= lang/perl5.8
144# By default, documentation (Handbook, FAQ, etc.) is built for all
145# the languages. To speed up building, set the DOC_LANG to just
146# the languages you need. (The language for the release notes is
147# controlled by the RELNOTES_LANG variable above.)
148#DOC_LANG= en_US.ISO8859-1
149DOCPORTS= textproc/docproj
150# Set this to wherever the distfiles required by release procedures.
151.if defined(DOCDISTFILES)
152# Respect DOCDISTFILES which is used before.
153RELEASEDISTFILES?= ${DOCDISTFILES}
154.else
155RELEASEDISTFILES?= ${.CURDIR}/../../ports/distfiles
156.endif
157# Set this to 1 if you want -P to be used for automatic keyboard detection
158# on the boot floppy. WARNING: Breaks on some Athlon (K7) motherboards.
159AUTO_KEYBOARD_DETECT?= 0
160
161.if !defined(NODOC)
162DIST_DOCS_ARCH_INDEP= readme errata
163DIST_DOCS_ARCH_DEP= installation relnotes hardware
164.endif
165
166# Things which without too much trouble can be considered variables
167# BASE_DISTS are special in that they get full /etc installation sets.
168#
169OTHER_DISTS?= catpages manpages games proflibs dict info doc ${ARCH_DISTS}
170BASE_DISTS?= base
171.if ${TARGET_ARCH} == "amd64"
172ARCH_DISTS?= lib32
173.endif
174DISTRIBUTIONS?= ${BASE_DISTS} ${OTHER_DISTS}
175
176#
177# Build and package both GENERIC and SMP kernels if the target
178# has both configuration files. Otherwise only GENERIC is done.
179#
180.if exists(${.CURDIR}/../sys/${TARGET}/conf/SMP)
181KERNELS_BASE?= GENERIC SMP
182.else
183KERNELS_BASE?= GENERIC
184.endif
185
186# mountpoint for filesystems.
187MNT= /mnt
188
189# Various floppy image parameters.
190#
191
192.undef MAKE_FLOPPIES
193.if ${TARGET_ARCH} == "i386"
194MAKE_FLOPPIES= true
195.if ${TARGET} == "pc98"
196SMALLFLOPPYSIZE= 1200
197SMALLFLOPPYSPLITSIZE= 1152
198SMALLFLOPPYLABEL= fd1200
199SPLIT_MFSROOT=
200.endif
201FLOPPYSIZE= 1440
202FLOPPYSPLITSIZE= 1392
203FLOPPYINODE= 40000
204FLOPPYLABEL= fd1440
205BOOTINODE= 80000
206MFSSIZE= 4320
207MFSINODE= 8000
208MFSLABEL= minimum3
209.elif ${TARGET_ARCH} == "alpha"
210MAKE_FLOPPIES= true
211FLOPPYSIZE= 1440
212FLOPPYSPLITSIZE= 1392
213FLOPPYINODE= 40000
214FLOPPYLABEL= fd1440
215BOOTINODE= 80000
216MFSSIZE= 4320
217MFSINODE= 8000
218MFSLABEL= auto
219SPLIT_MFSROOT=
220.elif ${TARGET_ARCH} == "sparc64"
221DISKLABEL= sunlabel
222MFSSIZE= 4096
223MFSINODE= 8192
224MFSLABEL= auto
225MINIROOT=
226.elif ${TARGET_ARCH} == "ia64"
227MFSSIZE= 8192
228MFSINODE= 8192
229MFSLABEL= auto
230SEPARATE_LIVEFS=
231.elif ${TARGET_ARCH} == "amd64"
232MAKE_FLOPPIES= true
233FLOPPYSIZE= 1440
234FLOPPYSPLITSIZE= 1392
235FLOPPYINODE= 40000
236FLOPPYLABEL= fd1440
237BOOTINODE= 80000
238MFSSIZE= 4096
239MFSINODE= 8192
240MFSLABEL= auto
241SPLIT_MFSROOT=
242.elif ${TARGET_ARCH} == "powerpc"
243DISKLABEL= ""
244MFSSIZE= 4096
245MFSINODE= 8192
246MFSLABEL= auto
247SEPARATE_LIVEFS=
248.endif
249.if defined(NO_FLOPPIES)
250.undef MAKE_FLOPPIES
251.endif
252
253.if exists(/sbin/bsdlabel)
254DISKLABEL?= bsdlabel
255.else
256DISKLABEL?= disklabel
257.endif
258
259ZIPNSPLIT= gzip --no-name -9 -c | split -b 1392k -
260
261# Things which may get you into trouble if you change them
262MTREEFILES= ${.CURDIR}/../etc/mtree
263_R?= /R
264RD= ${_R}/stage
265RND= ${RD}/release.doc
266FD= ${_R}/ftp
267CD= ${_R}/cdrom
268.if ${TARGET} != "pc98"
269CD_BOOT= ${CD}/bootonly
270.endif
271CD_DISC1= ${CD}/disc1
272CD_DISC2= ${CD}/disc2
273.if defined(SEPARATE_LIVEFS)
274CD_LIVEFS= ${CD}/livefs
275.else
276CD_LIVEFS= ${CD_DISC1}
277.endif
278_MK?= ${CHROOTDIR}/mk
279
280# Where the bootstrap ports (see DOCPORTS) get installed.
281LOCALDIR= /usr/local/bin
282
283.if ${TARGET} != ${MACHINE} && ${DISKLABEL} == "bsdlabel"
284DOFS_SH= ${.CURDIR}/scripts/doFS.sh ${DISKLABEL} ${TARGET}
285.else
286DOFS_SH= ${.CURDIR}/scripts/doFS.sh ${DISKLABEL} ""
287.endif
288
289CRUNCH_TARGETS= boot
290.if ${TARGET_ARCH} == "i386"
291CRUNCH_TARGETS+=fixit
292.if ${TARGET} == "pc98"
293CRUNCH_TARGETS+=fixit-small
294.endif
295.endif
296
297.if defined(MAKE_FLOPPIES)
298EXTRAS= floppies.1
299.if ${TARGET_ARCH} == "i386"
300EXTRAS+= floppies.2
301.endif
302EXTRAS+= floppies.3
303.endif
304EXTRAS+= ftp.1
305.if !defined(NOCDROM)
306EXTRAS+= cdrom.1 cdrom.2 cdrom.3
307.if defined(MAKE_ISOS)
308EXTRAS+= iso.1
309.endif
310.if ${TARGET} == "pc98"
311BOOTABLE=
312.else
313BOOTABLE="-b"
314.endif
315.endif
316
317.if !defined(NODOC)
318DOCREL= doc.1 doc.2
319.endif
320
321.if !make(release) && !make(rerelease) && !make(package-split)
322BINMAKE!= cd ${.CURDIR}/..; ${MAKE} -V BINMAKE
323WMAKEENV!= cd ${.CURDIR}/..; \
324 ${BINMAKE} ${CROSSENV} -f Makefile.inc1 -V WMAKEENV
325WMAKE= ${WMAKEENV} ${BINMAKE}
326.endif
327
328CVS_SRCARGS= -P
329.if defined(RELEASETAG)
330CVS_SRCARGS+= -r ${RELEASETAG}
331.endif
332
333CVS_DOCARGS= -P
334.if defined(DOCRELEASETAG)
335CVS_DOCARGS+= -r ${DOCRELEASETAG}
336.endif
337
338CVS_PORTSARGS= -P
339.if defined(PORTSRELEASETAG)
340CVS_PORTSARGS+= -r ${PORTSRELEASETAG}
341.endif
342
343WORLDDIR?= ${.CURDIR}/..
344
345release rerelease:
346.if !defined(CHROOTDIR) || !defined(BUILDNAME) || !defined(CVSROOT)
347 @echo "To make a release you must set CHROOTDIR, BUILDNAME and CVSROOT" && false
348.endif
349.if defined(NOPORTSATALL) && !defined(NODOC)
350 @echo "Ports are required for building the docs. Either set NODOC or"
351 @echo "unset NOPORTS, or set at least DOMINIMALDOCPORTS to YES!"
352 @exit 1
353.endif
354.if defined(LOCAL_PATCHES) && !empty(LOCAL_PATCHES)
355.for p in ${LOCAL_PATCHES}
356.if !exists(${p})
357 @echo "The patch file ${p} does not exist!"
358 @exit 1
359.endif
360.endfor
361.endif
362.if defined(LOCAL_SCRIPT) && !exists(${LOCAL_SCRIPT})
363 @echo "The local script ${LOCAL_SCRIPT} does not exist!"
364 @exit 1
365.endif
366.if make(release)
367.if exists(${CHROOTDIR})
368# The first command will fail on a handful of files that have their schg
369# flags set. But it greatly speeds up the next two commands.
370 # NB: clear any vestigial devfs mount, just in case
371 -umount ${CHROOTDIR}/dev > /dev/null 2>&1
372 -rm -rf ${CHROOTDIR} 2>/dev/null
373 -chflags -R 0 ${CHROOTDIR}/.
374 -rm -rf ${CHROOTDIR}
375.endif
376 mkdir -p ${CHROOTDIR}
377 @echo ">>> make release for ${TARGET} started on `LC_ALL=C TZ=GMT date`"
2#
3# make release [BUILDNAME=somename] CHROOTDIR=/some/dir CVSROOT=/cvs/dir \
4# [RELEASETAG=tag]
5#
6# Where "/some/dir" is the pathname of a directory on a some filesystem with
7# at least 1000MB of free space, "somename" is what you want the release to
8# call itself, "/cvs/dir" is where our source repo resides and, optionally,
9# which CVS "tag" name should be used when checking out the sources to build
10# the release (default is HEAD).
11#
12# Please note: the md(4) driver must be present in the kernel
13# (either by being compiled in or available as a kld(4) module),
14# otherwise the target 'release.8' and possibly others will fail.
15#
16# Note: If you add options to this file, please keep release(7) updated!
17#
18# Set these, release builder!
19#
20# Fixed version:
21#BUILDNAME=7.0-CURRENT
22#
23# Automatic SNAP versioning:
24DATE != date +%Y%m%d
25BASE = 7.0
26BUILDNAME?=${BASE}-${DATE}-SNAP
27#
28#CHROOTDIR=/junk/release
29# If this is a -stable snapshot, then set
30#RELEASETAG=RELENG_6
31#
32# To test a release with a source tree containing patches and
33# other work. This tree will get copied instead of getting the
34# src/ tree from a CVS checkout. For "rerelease", this will NOT
35# be copied; cvs update will be used instead.
36#EXTSRCDIR=/usr/src
37#
38# To use a checked-out ports collection directory instead of
39# checking out from a local CVS repository, set this option.
40#EXTPORTSDIR=/usr/ports
41#
42# To add other options to the CVS subcommands (co,up), set
43#CVSCMDARGS="-D '01/01/2002 00:00:00 UTC'"
44#
45# To add other options to the CVS command, set
46#CVSARGS="-lfq"
47#
48# To prefix the cvs command
49#CVSPREFIX="/usr/bin/time"
50#
51# Where the CVS repository is
52#CVSROOT="/home/ncvs"
53#
54# Non-zero if ${RELEASETAG} is in the form "RELENG_ver_RELEASE"; we
55# are building an official release. Otherwise, we are building for
56# a branch.
57.if defined(RELEASETAG)
58ISRELEASE!= expr "${RELEASETAG}" : '^RELENG_.*_RELEASE$$' || true
59.if ${ISRELEASE} != 0
60# Convert "RELENG_ver_RELEASE" to "RELEASE_ver" for ports and doc trees.
61AUXRELEASETAG!= echo ${RELEASETAG} | sed -e 's/^RELENG_/RELEASE_/' -e 's/_RELEASE$$//'
62DOCRELEASETAG?= ${AUXRELEASETAG}
63PORTSRELEASETAG?= ${AUXRELEASETAG}
64.endif
65.endif
66
67# If you want to pass flags to the world build such as -j X, use
68# WORLD_FLAGS. Similarly, you can specify make flags for kernel
69# builds via KERNEL_FLAGS.
70#WORLD_FLAGS=-j4
71#KERNEL_FLAGS=-j4
72
73TARGET_ARCH?= ${MACHINE_ARCH}
74.if ${TARGET_ARCH} == ${MACHINE_ARCH}
75TARGET?= ${MACHINE}
76.else
77TARGET?= ${TARGET_ARCH}
78.endif
79CROSSENV= TARGET_ARCH=${TARGET_ARCH} TARGET=${TARGET}
80CROSSMAKE= ${MAKE} ${CROSSENV}
81NATIVEMAKE= ${MAKE} TARGET_ARCH=${MACHINE_ARCH} TARGET=${MACHINE}
82
83# If you are using a local CVS repository with components stored in
84# non-standard modules, override these on the make commandline or
85# in the environment.
86RELEASESRCMODULE?= src
87RELEASEDOCMODULE?= doc
88RELEASEPORTSMODULE?= ports
89
90# Uncomment this to disable the doc.1 target. Docs normally require
91# the ports tree, so NOPORTS can be set together with NODOC in order
92# to have neither ports or docs. If only NOPORTS is set to YES, but
93# docs are still desired, the DOMINIMALDOCPORTS logic below will only
94# install the ports that are minimally required for the docs. This is
95# intended as a compromise, less disk space is required than for using
96# the entire ports collection (and much less time due to the huge number
97# of directories it would create), but still quite a bit as well as some
98# CPU cycles (some of the programs are C++, and things like ghostscript
99# belong to the required ports nevertheless).
100#
101# Setting this also disables building of release note documentation
102# (RELNOTESng).
103#NODOC= YES
104#NOPORTS= YES
105
106# When retrieving ports using the pkg_add -r method, set your proxies to these.
107# src/release/${arch}/mkisoimages.sh can use these.
108#HTTP_PROXY?= www.example.com
109#FTP_PROXY?= ftp.example.com
110
111# When creating ISO images, point ${CD_PACKAGE_TREE} to a directory containing
112# the package split by an earlier invocation of the 'package-split' target.
113#CD_PACKAGE_TREE= /path/to/pkg
114
115# Extra source tarballs; each argument is a pair of source dir and
116# distribution name. The dist name should not exceed 7 characters
117# (another "s" for "source" will be prepended).
118#EXTRA_SRC= games/fortune fortune
119
120# Modify this definition if you want the release notes
121# and other release documentation in a language other than English.
122RELNOTES_LANG?= en_US.ISO8859-1
123
124# As an alternative to installing the entire ports collection (which
125# can take a huge amount of time, in particular on slower disks),
126# setting ${MINIMALDOCPORTS} allows to install and build just those
127# ports that are really required for getting the docs up & running.
128.if defined(NOPORTS) && !defined(NODOC)
129DOMINIMALDOCPORTS= YES
130.include "Makefile.inc.docports"
131RELEASEPORTSMODULE= ${MINIMALDOCPORTS}
132.endif
133
134# Helper variable
135.if defined(NOPORTS)
136.if !defined(DOMINIMALDOCPORTS) || ${DOMINIMALDOCPORTS} != "YES"
137NOPORTSATALL= YES
138.endif
139.endif
140
141#
142# Doing 'make index' in /usr/ports requires Perl.
143MAKEINDEXPORTS= lang/perl5.8
144# By default, documentation (Handbook, FAQ, etc.) is built for all
145# the languages. To speed up building, set the DOC_LANG to just
146# the languages you need. (The language for the release notes is
147# controlled by the RELNOTES_LANG variable above.)
148#DOC_LANG= en_US.ISO8859-1
149DOCPORTS= textproc/docproj
150# Set this to wherever the distfiles required by release procedures.
151.if defined(DOCDISTFILES)
152# Respect DOCDISTFILES which is used before.
153RELEASEDISTFILES?= ${DOCDISTFILES}
154.else
155RELEASEDISTFILES?= ${.CURDIR}/../../ports/distfiles
156.endif
157# Set this to 1 if you want -P to be used for automatic keyboard detection
158# on the boot floppy. WARNING: Breaks on some Athlon (K7) motherboards.
159AUTO_KEYBOARD_DETECT?= 0
160
161.if !defined(NODOC)
162DIST_DOCS_ARCH_INDEP= readme errata
163DIST_DOCS_ARCH_DEP= installation relnotes hardware
164.endif
165
166# Things which without too much trouble can be considered variables
167# BASE_DISTS are special in that they get full /etc installation sets.
168#
169OTHER_DISTS?= catpages manpages games proflibs dict info doc ${ARCH_DISTS}
170BASE_DISTS?= base
171.if ${TARGET_ARCH} == "amd64"
172ARCH_DISTS?= lib32
173.endif
174DISTRIBUTIONS?= ${BASE_DISTS} ${OTHER_DISTS}
175
176#
177# Build and package both GENERIC and SMP kernels if the target
178# has both configuration files. Otherwise only GENERIC is done.
179#
180.if exists(${.CURDIR}/../sys/${TARGET}/conf/SMP)
181KERNELS_BASE?= GENERIC SMP
182.else
183KERNELS_BASE?= GENERIC
184.endif
185
186# mountpoint for filesystems.
187MNT= /mnt
188
189# Various floppy image parameters.
190#
191
192.undef MAKE_FLOPPIES
193.if ${TARGET_ARCH} == "i386"
194MAKE_FLOPPIES= true
195.if ${TARGET} == "pc98"
196SMALLFLOPPYSIZE= 1200
197SMALLFLOPPYSPLITSIZE= 1152
198SMALLFLOPPYLABEL= fd1200
199SPLIT_MFSROOT=
200.endif
201FLOPPYSIZE= 1440
202FLOPPYSPLITSIZE= 1392
203FLOPPYINODE= 40000
204FLOPPYLABEL= fd1440
205BOOTINODE= 80000
206MFSSIZE= 4320
207MFSINODE= 8000
208MFSLABEL= minimum3
209.elif ${TARGET_ARCH} == "alpha"
210MAKE_FLOPPIES= true
211FLOPPYSIZE= 1440
212FLOPPYSPLITSIZE= 1392
213FLOPPYINODE= 40000
214FLOPPYLABEL= fd1440
215BOOTINODE= 80000
216MFSSIZE= 4320
217MFSINODE= 8000
218MFSLABEL= auto
219SPLIT_MFSROOT=
220.elif ${TARGET_ARCH} == "sparc64"
221DISKLABEL= sunlabel
222MFSSIZE= 4096
223MFSINODE= 8192
224MFSLABEL= auto
225MINIROOT=
226.elif ${TARGET_ARCH} == "ia64"
227MFSSIZE= 8192
228MFSINODE= 8192
229MFSLABEL= auto
230SEPARATE_LIVEFS=
231.elif ${TARGET_ARCH} == "amd64"
232MAKE_FLOPPIES= true
233FLOPPYSIZE= 1440
234FLOPPYSPLITSIZE= 1392
235FLOPPYINODE= 40000
236FLOPPYLABEL= fd1440
237BOOTINODE= 80000
238MFSSIZE= 4096
239MFSINODE= 8192
240MFSLABEL= auto
241SPLIT_MFSROOT=
242.elif ${TARGET_ARCH} == "powerpc"
243DISKLABEL= ""
244MFSSIZE= 4096
245MFSINODE= 8192
246MFSLABEL= auto
247SEPARATE_LIVEFS=
248.endif
249.if defined(NO_FLOPPIES)
250.undef MAKE_FLOPPIES
251.endif
252
253.if exists(/sbin/bsdlabel)
254DISKLABEL?= bsdlabel
255.else
256DISKLABEL?= disklabel
257.endif
258
259ZIPNSPLIT= gzip --no-name -9 -c | split -b 1392k -
260
261# Things which may get you into trouble if you change them
262MTREEFILES= ${.CURDIR}/../etc/mtree
263_R?= /R
264RD= ${_R}/stage
265RND= ${RD}/release.doc
266FD= ${_R}/ftp
267CD= ${_R}/cdrom
268.if ${TARGET} != "pc98"
269CD_BOOT= ${CD}/bootonly
270.endif
271CD_DISC1= ${CD}/disc1
272CD_DISC2= ${CD}/disc2
273.if defined(SEPARATE_LIVEFS)
274CD_LIVEFS= ${CD}/livefs
275.else
276CD_LIVEFS= ${CD_DISC1}
277.endif
278_MK?= ${CHROOTDIR}/mk
279
280# Where the bootstrap ports (see DOCPORTS) get installed.
281LOCALDIR= /usr/local/bin
282
283.if ${TARGET} != ${MACHINE} && ${DISKLABEL} == "bsdlabel"
284DOFS_SH= ${.CURDIR}/scripts/doFS.sh ${DISKLABEL} ${TARGET}
285.else
286DOFS_SH= ${.CURDIR}/scripts/doFS.sh ${DISKLABEL} ""
287.endif
288
289CRUNCH_TARGETS= boot
290.if ${TARGET_ARCH} == "i386"
291CRUNCH_TARGETS+=fixit
292.if ${TARGET} == "pc98"
293CRUNCH_TARGETS+=fixit-small
294.endif
295.endif
296
297.if defined(MAKE_FLOPPIES)
298EXTRAS= floppies.1
299.if ${TARGET_ARCH} == "i386"
300EXTRAS+= floppies.2
301.endif
302EXTRAS+= floppies.3
303.endif
304EXTRAS+= ftp.1
305.if !defined(NOCDROM)
306EXTRAS+= cdrom.1 cdrom.2 cdrom.3
307.if defined(MAKE_ISOS)
308EXTRAS+= iso.1
309.endif
310.if ${TARGET} == "pc98"
311BOOTABLE=
312.else
313BOOTABLE="-b"
314.endif
315.endif
316
317.if !defined(NODOC)
318DOCREL= doc.1 doc.2
319.endif
320
321.if !make(release) && !make(rerelease) && !make(package-split)
322BINMAKE!= cd ${.CURDIR}/..; ${MAKE} -V BINMAKE
323WMAKEENV!= cd ${.CURDIR}/..; \
324 ${BINMAKE} ${CROSSENV} -f Makefile.inc1 -V WMAKEENV
325WMAKE= ${WMAKEENV} ${BINMAKE}
326.endif
327
328CVS_SRCARGS= -P
329.if defined(RELEASETAG)
330CVS_SRCARGS+= -r ${RELEASETAG}
331.endif
332
333CVS_DOCARGS= -P
334.if defined(DOCRELEASETAG)
335CVS_DOCARGS+= -r ${DOCRELEASETAG}
336.endif
337
338CVS_PORTSARGS= -P
339.if defined(PORTSRELEASETAG)
340CVS_PORTSARGS+= -r ${PORTSRELEASETAG}
341.endif
342
343WORLDDIR?= ${.CURDIR}/..
344
345release rerelease:
346.if !defined(CHROOTDIR) || !defined(BUILDNAME) || !defined(CVSROOT)
347 @echo "To make a release you must set CHROOTDIR, BUILDNAME and CVSROOT" && false
348.endif
349.if defined(NOPORTSATALL) && !defined(NODOC)
350 @echo "Ports are required for building the docs. Either set NODOC or"
351 @echo "unset NOPORTS, or set at least DOMINIMALDOCPORTS to YES!"
352 @exit 1
353.endif
354.if defined(LOCAL_PATCHES) && !empty(LOCAL_PATCHES)
355.for p in ${LOCAL_PATCHES}
356.if !exists(${p})
357 @echo "The patch file ${p} does not exist!"
358 @exit 1
359.endif
360.endfor
361.endif
362.if defined(LOCAL_SCRIPT) && !exists(${LOCAL_SCRIPT})
363 @echo "The local script ${LOCAL_SCRIPT} does not exist!"
364 @exit 1
365.endif
366.if make(release)
367.if exists(${CHROOTDIR})
368# The first command will fail on a handful of files that have their schg
369# flags set. But it greatly speeds up the next two commands.
370 # NB: clear any vestigial devfs mount, just in case
371 -umount ${CHROOTDIR}/dev > /dev/null 2>&1
372 -rm -rf ${CHROOTDIR} 2>/dev/null
373 -chflags -R 0 ${CHROOTDIR}/.
374 -rm -rf ${CHROOTDIR}
375.endif
376 mkdir -p ${CHROOTDIR}
377 @echo ">>> make release for ${TARGET} started on `LC_ALL=C TZ=GMT date`"
378 cd ${WORLDDIR} && ${NATIVEMAKE} -DWITHOUT_GAMES -DWITHOUT_HTML -DNO_LIB32 \
379 -DWITHOUT_MAN -DWITHOUT_NLS -DNO_PROFILE installworld DESTDIR=${CHROOTDIR}
378 cd ${WORLDDIR} && ${NATIVEMAKE} -DWITHOUT_GAMES -DWITHOUT_HTML -DWITHOUT_LIB32 \
379 -DWITHOUT_MAN -DWITHOUT_NLS -DWITHOUT_PROFILE installworld DESTDIR=${CHROOTDIR}
380 cd ${WORLDDIR} && ${NATIVEMAKE} distribution DESTDIR=${CHROOTDIR}
381 if [ -f /etc/resolv.conf ]; then \
382 cp -p /etc/resolv.conf ${CHROOTDIR}/etc; \
383 fi
384.if defined(EXTLOCALDIR)
385 rm -rf ${CHROOTDIR}/usr/local
386 cd ${CHROOTDIR}/usr && cp -R -H ${EXTLOCALDIR} local
387.endif
388 rm -rf ${CHROOTDIR}/usr/src
389.if defined(EXTSRCDIR)
390 cd ${CHROOTDIR}/usr && \
391 cp -R -H ${EXTSRCDIR} src
392.else
393 cd ${CHROOTDIR}/usr && \
394 ${CVSPREFIX} cvs -R ${CVSARGS} -d ${CVSROOT} \
395 co ${CVSCMDARGS} ${CVS_SRCARGS} ${RELEASESRCMODULE}
396.endif
397.if defined(LOCAL_PATCHES) && !empty(LOCAL_PATCHES)
398.for p in ${LOCAL_PATCHES}
399 patch -d ${CHROOTDIR}/usr/${RELEASESRCMODULE} ${PATCH_FLAGS} < ${p}
400.endfor
401.endif
402.if defined(LOCAL_SCRIPT)
403 cd ${CHROOTDIR} && env CHROOTDIR=${CHROOTDIR} BUILDNAME=${BUILDNAME} \
404 RELEASETAG=${RELEASETAG} ${LOCAL_SCRIPT}
405.endif
406 rm -rf ${CHROOTDIR}/usr/ports
407.if !defined(NOPORTSATALL)
408.if defined(EXTPORTSDIR)
409 cd ${CHROOTDIR}/usr && cp -R -H ${EXTPORTSDIR} ports
410 # If there are distfiles downloaded removing them
411 rm -rf ports/distfiles/*
412.else
413 cd ${CHROOTDIR}/usr && ${CVSPREFIX} cvs -R ${CVSARGS} -d ${CVSROOT} \
414 co ${CVSCMDARGS} ${CVS_PORTSARGS} ${RELEASEPORTSMODULE}
415.endif
416.endif
417.if !defined(NODOC)
418 rm -rf ${CHROOTDIR}/usr/doc
419.if defined(EXTDOCDIR)
420 cd ${CHROOTDIR}/usr && cp -R -H ${EXTDOCDIR} doc
421.else
422 cd ${CHROOTDIR}/usr && ${CVSPREFIX} cvs -R ${CVSARGS} -d ${CVSROOT} \
423 co ${CVSCMDARGS} ${CVS_DOCARGS} ${RELEASEDOCMODULE}
424.endif
425 if [ -d ${RELEASEDISTFILES}/ ]; then \
426 cp -rp ${RELEASEDISTFILES} ${CHROOTDIR}/usr/ports/distfiles; \
427 else \
428 mkdir -p ${CHROOTDIR}/usr/ports/distfiles; \
429 fi
430.if !defined(NO_PREFETCHDISTFILES)
431 @cd ${.CURDIR} && ${MAKE} fetch-distfiles
432.endif
433.endif
434.endif
435.if make(rerelease)
436.if !defined(RELEASENOUPDATE)
437.if !defined(RELEASETAG)
438 cd ${CHROOTDIR}/usr/src && ${CVSPREFIX} cvs -R ${CVSARGS} -q \
439 update ${CVSCMDARGS} -P -d -A
440.else
441 cd ${CHROOTDIR}/usr/src && ${CVSPREFIX} cvs -R ${CVSARGS} -q \
442 update ${CVSCMDARGS} -P -d -r ${RELEASETAG}
443.endif
444 rm -f ${CHROOTDIR}/tmp/.world_done
445.if !defined(NOPORTS) && !defined(EXTPORTSDIR)
446 cd ${CHROOTDIR}/usr/ports && ${CVSPREFIX} cvs -R ${CVSARGS} -q \
447 update ${CVSCMDARGS} -P -d
448 rm -f ${CHROOTDIR}/tmp/.skip_ports_index
449.endif
450.if defined(DOMINIMALDOCPORTS) && ${DOMINIMALDOCPORTS} == "YES"
451 for i in ${MINIMALDOCPORTS}; do \
452 ( cd ${CHROOTDIR}/usr/$$i && ${CVSPREFIX} cvs -R ${CVSARGS} -q \
453 update ${CVSCMDARGS} -P -d ) ; \
454 done
455.endif
456.if !defined(NODOC)
457 cd ${CHROOTDIR}/usr/doc && ${CVSPREFIX} cvs -R ${CVSARGS} -q \
458 update ${CVSCMDARGS} -P -d
459.endif
460.endif
461.endif
462 # Add version information to those things that need it.
463 if [ ! -f ${CHROOTDIR}/tmp/.world_done ]; then \
464 cd ${CHROOTDIR}/usr/src/sys/conf && \
465 mv newvers.sh foo && \
466 sed "s/^RELEASE=.*/RELEASE=${BUILDNAME}/" foo > newvers.sh && \
467 rm foo; \
468 fi
469 -test -f install.cfg && cp install.cfg ${CHROOTDIR}/usr/src/release
470 echo "#!/bin/sh" > ${_MK}
471 echo "set -ex" >> ${_MK}
472 echo "trap 'umount /dev || true' 0" >> ${_MK}
473 echo "_RELTARGET=\$${1:-doRELEASE}" >> ${_MK}
474.for var in \
475 AUTO_KEYBOARD_DETECT \
476 BUILDNAME \
477 CD_PACKAGE_TREE \
478 DISTRIBUTIONS \
479 DOC_LANG \
480 DOMINIMALDOCPORTS \
481 EXTRA_SRC \
482 FTP_PASSIVE_MODE \
483 FTP_PROXY \
484 HTTP_PROXY \
485 KERNELS \
486 KERNELS_BASE \
487 KERNEL_FLAGS \
488 MAKE_FLOPPIES \
489 MAKE_ISOS \
490 NOCDROM \
491 NODOC \
492 NOPORTS \
493 NO_SHARED \
494 NOSRC \
495 NO_CPU_CFLAGS \
496 NO_CPU_COPTFLAGS \
497 NO_FLOPPIES \
498 RELEASETAG \
499 RELNOTES_LANG \
500 SEPARATE_LIVEFS \
501 TARGET \
502 TARGET_ARCH \
503 WORLD_FLAGS
504.if defined(${var})
505 echo "export ${var}=\"${${var}}\"" >> ${_MK}
506.endif
507.endfor
508 # Don't remove this, or the build will fall over!
509 echo "export RELEASEDIR=${_R}" >> ${_MK}
510 echo "export PATH=/bin:/usr/bin:/sbin:/usr/sbin:${LOCALDIR}" >> ${_MK}
511 echo "export MANBUILDCAT=YES" >> ${_MK}
512 # NB: these may fail if the host is running w/o devfs
513 echo "umount /dev >/dev/null 2>&1 || true" >> ${_MK}
514 echo "mount -t devfs devfs /dev >/dev/null 2>&1 || true" >> ${_MK}
515 echo "if [ -x /etc/rc.d/ldconfig ]; then" >> ${_MK}
516 echo " /etc/rc.d/ldconfig start" >> ${_MK}
517 echo "else" >> ${_MK}
518 echo " ldconfig /lib /usr/lib /usr/local/lib || true" >> ${_MK}
519 echo "fi" >> ${_MK}
520 echo "if [ ! -f /tmp/.world_done ]; then" >> ${_MK}
521 echo " cd /usr/src" >> ${_MK}
522 echo " ${CROSSMAKE} ${WORLD_FLAGS} -DNO_CLEAN buildworld && \\" >> ${_MK}
523 echo " touch /tmp/.world_done || exit 1" >> ${_MK}
524 echo "fi" >> ${_MK}
525 echo "if [ ! -f /tmp/.skip_ports_index ]; then" >> ${_MK}
526 echo " echo \">>> make index started on \`LC_ALL=C TZ=GMT date\`\"" >> ${_MK}
527 echo " for i in ${MAKEINDEXPORTS}" >> ${_MK}
528 echo " do" >> ${_MK}
529 echo " cd /usr/ports/\$${i}" >> ${_MK}
530 echo " env -i FTP_PASSIVE_MODE=$${FTP_PASSIVE_MODE:-no} PATH=$${PATH} \\" >> ${_MK}
531 echo " make all install clean BATCH=yes FORCE_PKG_REGISTER=yes" >> ${_MK}
532 echo " done" >> ${_MK}
533 echo " cd /usr/ports" >> ${_MK}
534 echo " rm -f INDEX*" >> ${_MK}
535 echo " make index -DINDEX_PRISTINE" >> ${_MK}
536 echo " rm -f INDEX*.tmp" >> ${_MK}
537 echo " touch /tmp/.skip_ports_index" >> ${_MK}
538 echo " echo \">>> make index finished on \`LC_ALL=C TZ=GMT date\`\"" >> ${_MK}
539 echo "fi" >> ${_MK}
540 echo "cd /usr/src/release" >> ${_MK}
541 echo "make obj" >> ${_MK}
542 echo "make \$${_RELTARGET}" >> ${_MK}
543 echo "echo \">>> make ${.TARGET} for ${TARGET} finished on \`LC_ALL=C TZ=GMT date\`\"" >> ${_MK}
544 chmod 755 ${_MK}
545.if defined(NOPORTS)
546 touch ${CHROOTDIR}/tmp/.skip_ports_index
547.endif
548 # Ensure md.ko is loaded if md(4) is not statically compiled into
549 # the kernel
550 -mdconfig 2>/dev/null
551 env -i /usr/sbin/chroot `dirname ${_MK}` /`basename ${_MK}`
552
553clean:
554 rm -rf ${CRUNCH_TARGETS:S/$/_crunch/} release.[0-8] ${EXTRAS}
555
556fetch-distfiles:
557 @for i in ${MAKEINDEXPORTS}; do \
558 cd ${CHROOTDIR}/usr/ports/$$i && \
559 make PORTSDIR=${CHROOTDIR}/usr/ports BATCH=yes \
560 checksum-recursive ; \
561 done
562 @for i in ${DOCPORTS}; do \
563 cd ${CHROOTDIR}/usr/ports/$$i && \
564 make PORTSDIR=${CHROOTDIR}/usr/ports BATCH=yes \
565 WITHOUT_X11=yes JADETEX=no WITHOUT_PYTHON=yes \
566 checksum-recursive ; \
567 done
568
569# Clean out ${_R} and make the directory structure.
570release.1:
571 mkdir -p ${_R}
572 -rm -rf ${_R}/* 2> /dev/null
573 -chflags -R noschg ${_R}/.
574 rm -rf ${_R}/*
575 mkdir ${RD}
576.if defined(MAKE_FLOPPIES)
577 mkdir ${RD}/floppies
578.endif
579 mkdir ${RD}/trees
580 for i in ${DISTRIBUTIONS}; do \
581 mkdir ${RD}/trees/$$i && \
582 mtree -deU -f ${MTREEFILES}/BSD.root.dist \
583 -p ${RD}/trees/$$i > /dev/null && \
584 mtree -deU -f ${MTREEFILES}/BSD.usr.dist \
585 -p ${RD}/trees/$$i/usr > /dev/null && \
586 mtree -deU -f ${MTREEFILES}/BSD.include.dist \
587 -p ${RD}/trees/$$i/usr/include > /dev/null && \
588 mtree -deU -f ${MTREEFILES}/BSD.var.dist \
589 -p ${RD}/trees/$$i/var > /dev/null ; \
590 done
591 mkdir ${RD}/kernels
592 for i in ${KERNELS_BASE} ${KERNELS}; do \
593 mkdir -p ${RD}/kernels/$${i}; \
594 done
595 touch ${.TARGET}
596
597# Install the system into the various distributions.
598release.2:
599 cd ${.CURDIR}/../etc && make distrib-dirs DESTDIR=${RD}/trees/base
600 cd ${.CURDIR}/.. && ${CROSSMAKE} ${WORLD_FLAGS} distributeworld \
601 DISTDIR=${RD}/trees
602 touch ${.TARGET}
603
604# Make and install the generic kernel(s).
605release.3:
606.for kernel in ${KERNELS_BASE} ${KERNELS}
607 cd ${.CURDIR}/..; \
608 ${CROSSMAKE} ${KERNEL_FLAGS} \
609 KERNCONF=${kernel} kernel \
610 DESTDIR=${RD}/kernels KODIR=/${kernel}
611.endfor
612 touch ${.TARGET}
613
614# Make and install the three crunched binaries which live on the floppies.
615# You are not supposed to like this :-)
616release.4:
617 rm -rf ${RD}/crunch
618 mkdir -p ${RD}/crunch
619.for j in ${CRUNCH_TARGETS}
620.if exists(${.CURDIR}/${TARGET}/${j}_crunch.conf)
621 rm -rf ${j}_crunch
622 mkdir ${j}_crunch
623 cd ${j}_crunch; ${WMAKEENV} crunchgen -o \
624 ${.CURDIR}/${TARGET}/${j}_crunch.conf
625 cd ${j}_crunch; ${WMAKE} -f ${j}_crunch.mk subclean
626 cd ${.CURDIR}/..; ${BINMAKE} -f Makefile.inc1 _build-tools
627 cd ${j}_crunch; CFLAGS="-Os -pipe" ${WMAKE} -f ${j}_crunch.mk \
628 -DNO_CPU_CFLAGS all
629 ${WMAKEENV} strip -R .comment ${j}_crunch/${j}_crunch
630 mv ${j}_crunch/${j}_crunch ${RD}/crunch/${j}
631.endif
632.endfor
633 touch ${.TARGET}
634
635#
636# --==## Fix up the distributions. ##==--
637#
638release.5:
639 # Create any "synthetic dists" now.
640 @for i in ${DISTRIBUTIONS}; do \
641 if [ -f ${.CURDIR}/scripts/$${i}-make.sh ]; then \
642 echo -n "Running $$i dist creation script... "; \
643 env RD=${RD} sh ${.CURDIR}/scripts/$${i}-make.sh || echo "$$i distribution script returned bad status."; \
644 echo "Done."; \
645 fi \
646 done \
647
648 # Remove all the directories we don't need.
649 -cd ${RD}/trees && \
650 (find ${OTHER_DISTS} -path '*/var/empty' | xargs chflags noschg; \
651 find ${OTHER_DISTS} -depth -type d -print | xargs rmdir)
652 touch ${.TARGET}
653
654#
655# --==## Package up the tarballs from assembled trees ##==--
656#
657release.6:
658 rm -rf ${RD}/dists
659 mkdir -p ${RD}/dists
660 @for i in ${DISTRIBUTIONS} ; \
661 do \
662 if [ -d ${RD}/trees/$${i} ] ; then \
663 cd ${.CURDIR} && $(MAKE) doTARBALL \
664 SD=${RD}/trees/$${i} \
665 TN=$$i TD=$$i ARG="." && \
666 echo "$${i} distribution is finished."; \
667 fi ; \
668 done
669 @for i in ${KERNELS_BASE} ${KERNELS} ; \
670 do \
671 if [ -d ${RD}/kernels/$${i} ] ; then \
672 cd ${.CURDIR} && $(MAKE) doTARBALL \
673 SD=${RD}/kernels \
674 TN=$$i TD=kernels ARG="$$i" && \
675 echo "$${i} distribution is finished."; \
676 fi ; \
677 done
678.if !defined(NOPORTS)
679 # XXX: Inline stripped version of doTARBALL
680 @rm -rf ${RD}/dists/ports/ports*
681 @mkdir -p ${RD}/dists/ports
682 @echo rolling ports/ports tarball
683 @tar --exclude CVS --exclude 'ports/distfiles/*' \
684 -czf ${RD}/dists/ports/ports.tgz -C /usr ports
685 @cp ${.CURDIR}/scripts/ports-install.sh ${RD}/dists/ports/install.sh
686 @(cd ${RD}/dists/ports; \
687 rm -f CHECKSUM.MD5 CHECKSUM.SHA256; \
688 md5 * > .CHECKSUM.MD5; \
689 sha256 * > .CHECKSUM.SHA256; \
690 mv .CHECKSUM.MD5 CHECKSUM.MD5; \
691 mv .CHECKSUM.SHA256 CHECKSUM.SHA256)
692 @echo "ports distribution is finished."
693.endif
694 touch ${.TARGET}
695
696
697#
698# --==## Make source dists ##==--
699#
700release.7:
701.if !defined(NOSRC)
702 @cd ${.CURDIR} && $(MAKE) doTARBALL SD=/usr/src \
703 TD=src TN=sbase ARG="[A-Z]*"
704 @for i in `cd /usr/src && echo [a-z]*` ; do \
705 if [ -d /usr/src/$$i ] ; then \
706 cd ${.CURDIR} && $(MAKE) doTARBALL \
707 TN=`echo s$$i | tr -d '.' | \
708 sed -e 's/usr/u/' \
709 -e 's/kerberos5/krb5/'` \
710 SD=/usr/src TD=src ARG="$$i" ; \
711 fi ; \
712 done
713.if defined(EXTRA_SRC)
714 @set ${EXTRA_SRC} && \
715 while [ $$# -ge 2 ] ; do \
716 if [ -d /usr/src/$$1 ] ; then \
717 cd ${.CURDIR} && $(MAKE) doTARBALL \
718 SD=/usr/src TN="s$$2" TD=src ARG="$$1" ; \
719 fi && shift && shift ; \
720 done
721.endif
722 (cd ${RD}/dists/src; \
723 rm -f CHECKSUM.MD5 CHECKSUM.SHA256; \
724 md5 * > .CHECKSUM.MD5; \
725 sha256 * > .CHECKSUM.SHA256; \
726 mv .CHECKSUM.MD5 CHECKSUM.MD5; \
727 mv .CHECKSUM.SHA256 CHECKSUM.SHA256)
728 @echo "src distribution is finished."
729.endif
730 touch ${.TARGET}
731
732# Build the memory root filesystem.
733release.8:
734 cp ${RD}/trees/base/etc/disktab /etc
735 rm -rf ${RD}/mfsfd
736 mkdir ${RD}/mfsfd
737 cd ${RD}/mfsfd && \
738 mkdir -p etc/defaults dev mnt stand/etc/defaults stand/help \
739 var/empty
740 @cd ${.CURDIR} && $(MAKE) installCRUNCH CRUNCH=boot \
741 DIR=${RD}/mfsfd/stand ZIP=false
742 ( cd ${RD}/mfsfd && \
743 for dir in bin sbin ; do \
744 ln -sf /stand $$dir; \
745 done )
746 cp ${RD}/trees/base/sbin/dhclient-script ${RD}/mfsfd/stand
747.if ${TARGET} == "pc98"
748 cp ${.CURDIR}/../etc/defaults/pccard.conf \
749 ${RD}/mfsfd/etc/defaults/pccard.conf
750.endif
751 cp ${.CURDIR}/../etc/master.passwd ${RD}/mfsfd/etc/master.passwd
752 cp ${RD}/trees/base/etc/*pwd.db ${RD}/mfsfd/etc/
753 ( for F in defaults/rc.conf netconfig protocols ; do \
754 sed -e '/^#.*$$/d' -e 's/[:space:]*#.*$$//g' \
755 ${RD}/trees/base/etc/$$F > ${RD}/mfsfd/stand/etc/$$F ; \
756 done )
757 grep -E '^(ftp|nameserver|domain|sunrpc|cmd|nfsd)[^-\w]' \
758 ${RD}/trees/base/etc/services | \
759 sed -e '/^#.*$$/d' -e 's/[:space:]*#.*$$//g' \
760 > ${RD}/mfsfd/stand/etc/services
761 grep 'operator' ${RD}/trees/base/etc/group \
762 > ${RD}/mfsfd/stand/etc/group
763 ln ${RD}/mfsfd/stand/etc/services ${RD}/mfsfd/etc/services
764 ln ${RD}/mfsfd/stand/etc/group ${RD}/mfsfd/etc/group
765 ln ${RD}/mfsfd/stand/etc/netconfig ${RD}/mfsfd/etc/netconfig
766 cp ${RD}/trees/base/COPYRIGHT ${RD}/mfsfd/stand/help/COPYRIGHT.hlp
767.if !defined(NODOC)
768 @for i in ${DIST_DOCS_ARCH_INDEP}; do \
769 cp ${RND}/${RELNOTES_LANG}/$$i/article.txt \
770 ${RD}/mfsfd/stand/help/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
771 done
772 @for i in ${DIST_DOCS_ARCH_DEP}; do \
773 cp ${RND}/${RELNOTES_LANG}/$$i/${TARGET}/article.txt \
774 ${RD}/mfsfd/stand/help/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
775 done
776 @mv ${RD}/mfsfd/stand/help/INSTALLATION.TXT \
777 ${RD}/mfsfd/stand/help/INSTALL.TXT
778.endif
779 -test -f ${.CURDIR}/install.cfg \
780 && cp ${.CURDIR}/install.cfg ${RD}/mfsfd
781 @mkdir -p ${RD}/mfsfd/boot
782.if ${TARGET_ARCH} != "ia64" && ${TARGET_ARCH} != "powerpc"
783 @cp ${RD}/trees/base/boot/boot* ${RD}/mfsfd/boot
784.endif
785.if ${TARGET} == "i386" || ${TARGET_ARCH} == "amd64"
786 @cp ${RD}/trees/base/boot/mbr ${RD}/mfsfd/boot
787.endif
788 @tar --exclude CVS -cf - -C ${.CURDIR}/../usr.sbin/sysinstall help | \
789 tar xf - -C ${RD}/mfsfd/stand
790 @mkdir -p ${RD}/mfsroot
791 sh -e ${DOFS_SH} ${RD}/mfsroot/mfsroot ${RD} ${MNT} \
792 ${MFSSIZE} ${RD}/mfsfd ${MFSINODE} ${MFSLABEL}
793 @gzip -9fnv ${RD}/mfsroot/mfsroot
794 touch ${.TARGET}
795
796KERNFLOPPYSET= ${RD}/floppyset/kern/kernel.gz
797.if defined(SMALLFLOPPYSIZE)
798SMALLKERNFLOPPYSET= ${RD}/floppyset/kern-small/kernel.gz
799.endif
800.if defined(SPLIT_MFSROOT)
801MFSROOTFLOPPYSET= ${RD}/floppyset/mfsroot/mfsroot.gz
802.if defined(SMALLFLOPPYSIZE)
803SMALLMFSROOTFLOPPYSET= ${RD}/floppyset/mfsroot-small/mfsroot.gz
804.endif
805.endif
806
807# Build boot and install floppies.
808floppies.1:
809 @gzip -9nc ${RD}/kernels/GENERIC/kernel > ${RD}/kernels/kernel.gz
810 @echo "Making the kernel boot floppies..."
811 @cd ${.CURDIR} && ${MAKE} makeFloppySet FLOPPYBASE=kern \
812 FLOPPYDESC="Kernel" SPLITFILE=${RD}/kernels/kernel.gz
813.if defined(SMALLFLOPPYSIZE)
814 @echo "Making the small kernel boot floppies..."
815 @cd ${.CURDIR} && ${MAKE} makeFloppySet FLOPPYBASE=kern-small \
816 FLOPPYDESC="Kernel" SPLITFILE=${RD}/kernels/kernel.gz \
817 FDSIZE="SMALL"
818.endif
819.if defined(SPLIT_MFSROOT)
820 @echo "Making the mfsroot boot floppies..."
821 @cd ${.CURDIR} && ${MAKE} makeFloppySet FLOPPYBASE=mfsroot \
822 FLOPPYDESC="Memory Filesystem" SPLITFILE=${RD}/mfsroot/mfsroot.gz
823.if defined(SMALLFLOPPYSIZE)
824 @echo "Making the small mfsroot boot floppies..."
825 @cd ${.CURDIR} && ${MAKE} makeFloppySet FLOPPYBASE=mfsroot-small \
826 FLOPPYDESC="Memory Filesystem" SPLITFILE=${RD}/mfsroot/mfsroot.gz \
827 FDSIZE="SMALL"
828.endif
829 @cd ${.CURDIR} && ${MAKE} buildBootFloppy FSIMAGE="boot" \
830 KERNFILE="${KERNFLOPPYSET}.split ${KERNFLOPPYSET}.boot" \
831 MFSROOTFILE="${MFSROOTFLOPPYSET}.split ${MFSROOTFLOPPYSET}.boot"
832.if defined(SMALLFLOPPYSIZE)
833 @cd ${.CURDIR} && ${MAKE} buildBootFloppy FSIMAGE="boot-small" \
834 KERNFILE="${SMALLKERNFLOPPYSET}.split ${SMALLKERNFLOPPYSET}.boot" \
835 MFSROOTFILE="${SMALLMFSROOTFLOPPYSET}.split ${SMALLMFSROOTFLOPPYSET}.boot" \
836 FDSIZE="SMALL"
837.endif
838.else # !SPLIT_MFSROOT
839 @cd ${.CURDIR} && ${MAKE} buildBootFloppy FSIMAGE="boot" \
840 KERNFILE="${KERNFLOPPYSET}.split ${KERNFLOPPYSET}.boot" \
841 MFSROOTFILE=${RD}/mfsroot/mfsroot.gz
842.if defined(SMALLFLOPPYSIZE)
843 @cd ${.CURDIR} && ${MAKE} buildBootFloppy FSIMAGE="boot-small" \
844 KERNFILE="${SMALLKERNFLOPPYSET}.split ${SMALLKERNFLOPPYSET}.boot" \
845 MFSROOTFILE=${RD}/mfsroot/mfsroot.gz \
846 FDSIZE="SMALL"
847.endif
848.endif # SPLIT_MFSROOT
849 touch ${.TARGET}
850
851# Build fixit floppy.
852floppies.2:
853 @echo "Making fixit floppy."
854 @rm -rf ${RD}/fixitfd
855 @mkdir ${RD}/fixitfd
856 @cd ${RD}/fixitfd && \
857 mkdir -p dev stand bin sbin etc mnt mnt1 mnt2 mnt3 mnt4 tmp \
858 usr/share/misc
859 @cp ${RD}/trees/base/etc/spwd.db ${RD}/trees/base/etc/group \
860 ${RD}/fixitfd/etc
861 @sed -e 's/#.*//' ${RD}/trees/base/etc/protocols \
862 > ${RD}/fixitfd/etc/protocols
863 @sed -e 's/#.*//' ${RD}/trees/base/usr/share/misc/scsi_modes \
864 > ${RD}/fixitfd/usr/share/misc/scsi_modes
865 @cp ${.CURDIR}/fixit.profile ${RD}/fixitfd/.profile
866 @cp ${.CURDIR}/fixit.services ${RD}/fixitfd/etc/services
867 @cp ${.CURDIR}/scripts/tar.sh ${RD}/fixitfd/stand/tar
868 @chmod 555 ${RD}/fixitfd/stand/tar
869.if defined(SMALLFLOPPYSIZE)
870 @cd ${.CURDIR} && ${MAKE} installCRUNCH CRUNCH=fixit-small \
871 DIR=${RD}/fixitfd/stand ZIP=false
872 @sh -e ${DOFS_SH} ${RD}/floppies/fixit-small.flp ${RD} ${MNT} \
873 ${SMALLFLOPPYSIZE} ${RD}/fixitfd ${FLOPPYINODE} ${SMALLFLOPPYLABEL}
874 @rm -rf ${RD}/fixitfd/stand
875 @mkdir ${RD}/fixitfd/stand
876.endif
877 @cd ${.CURDIR} && ${MAKE} installCRUNCH CRUNCH=fixit \
878 DIR=${RD}/fixitfd/stand ZIP=false
879 @sh -e ${DOFS_SH} ${RD}/floppies/fixit.flp ${RD} ${MNT} \
880 ${FLOPPYSIZE} ${RD}/fixitfd ${FLOPPYINODE} ${FLOPPYLABEL}
881 touch ${.TARGET}
882
883# Do our last minute floppies directory setup
884floppies.3:
885.if !defined(NODOC)
886 @cp ${RND}/${RELNOTES_LANG}/installation/${TARGET}/article.txt \
887 ${RD}/floppies/README.TXT
888 @(cd ${RD}/floppies; md5 README.TXT *.flp > CHECKSUM.MD5)
889 @(cd ${RD}/floppies; sha256 README.TXT *.flp > CHECKSUM.SHA256)
890.else
891 @(cd ${RD}/floppies; md5 *.flp > CHECKSUM.MD5)
892 @(cd ${RD}/floppies; sha256 *.flp > CHECKSUM.SHA256)
893.endif
894 touch ${.TARGET}
895
896#
897# --==## Setup a suitable ftp-area ##==--
898#
899ftp.1:
900 @echo "Setting up FTP distribution area"
901 @mkdir -p ${FD}
902 -@ln -s . ${FD}/${BUILDNAME}
903.if defined(MAKE_FLOPPIES)
904 @cd ${RD} && find floppies -print | cpio -dumpl ${FD}
905.endif
906 @cd ${RD}/dists && find . -print | cpio -dumpl ${FD}
907.if !defined(NODOC)
908 @for i in ${DIST_DOCS_ARCH_INDEP}; do \
909 cp ${RND}/${RELNOTES_LANG}/$$i/article.txt \
910 ${FD}/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
911 cp ${RND}/${RELNOTES_LANG}/$$i/article.html \
912 ${FD}/`echo $${i} | tr 'a-z' 'A-Z'`.HTM; \
913 done
914 @for i in ${DIST_DOCS_ARCH_DEP}; do \
915 cp ${RND}/${RELNOTES_LANG}/$$i/${TARGET}/article.txt \
916 ${FD}/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
917 cp ${RND}/${RELNOTES_LANG}/$$i/${TARGET}/article.html \
918 ${FD}/`echo $${i} | tr 'a-z' 'A-Z'`.HTM; \
919 done
920 @cp ${RND}/${RELNOTES_LANG}/readme/docbook.css ${FD}
921 @mv ${FD}/INSTALLATION.TXT ${FD}/INSTALL.TXT
922 @mv ${FD}/INSTALLATION.HTM ${FD}/INSTALL.HTM
923.endif
924 @echo "CD_VERSION = ${BUILDNAME}" > ${FD}/cdrom.inf
925 touch ${.TARGET}
926
927# Build a live filesystem cdrom image
928cdrom.1:
929 @echo "Building CDROM live filesystem image"
930 @mkdir -p ${CD_LIVEFS}
931 @for i in ${DISTRIBUTIONS} ; \
932 do \
933 if [ -d ${RD}/trees/$${i} ] ; then \
934 chflags -R noschg ${RD}/trees/$${i} || true ; \
935 ( cd ${RD}/trees/$${i} && \
936 find . -depth -print | cpio -dumpl ${CD_LIVEFS} ) ; \
937 fi \
938 done
939 @echo "Copy GENERIC kernel to boot area"
940 @cp -Rp ${RD}/kernels/GENERIC/ ${CD_LIVEFS}/boot/kernel
941 @rm -f ${CD_LIVEFS}/.profile
942 @cp ${.CURDIR}/fixit.profile ${CD_LIVEFS}/.profile
943 @ln -sf /rescue ${CD_LIVEFS}/stand
944.if ${TARGET} != "pc98"
945 @echo "Setting up CDROM boot area"
946 @rm -f ${CD_LIVEFS}/boot/loader.conf
947 @cp ${RD}/mfsroot/mfsroot.gz ${CD_LIVEFS}/boot/mfsroot.gz
948 @echo 'mfsroot_load="YES"' > ${CD_LIVEFS}/boot/loader.conf
949 @echo 'mfsroot_type="mfs_root"' >> ${CD_LIVEFS}/boot/loader.conf
950 @echo 'mfsroot_name="/boot/mfsroot"' >> ${CD_LIVEFS}/boot/loader.conf
951.if exists(${RD}/trees/base/boot/device.hints)
952 # Break the link to device.hints so we can modify it
953 @rm -f ${CD_LIVEFS}/boot/device.hints
954 @cp ${RD}/trees/base/boot/device.hints ${CD_LIVEFS}/boot/device.hints
955.if ${TARGET} == "i386" || ${TARGET_ARCH} == "amd64"
956 @echo 'hint.atkbd.0.flags="0x1"' >> ${CD_LIVEFS}/boot/device.hints
957.endif
958.endif
959.endif
960 @echo "CD_VERSION = ${BUILDNAME}" > ${CD_LIVEFS}/cdrom.inf
961 touch ${.TARGET}
962
963# Build disc1 and disc2 cdrom images
964cdrom.2:
965 @echo "Building CDROM disc1 filesystem image"
966 @mkdir -p ${CD_DISC1}/${BUILDNAME}
967.if defined(MAKE_FLOPPIES)
968 @cd ${RD} && find floppies -print | cpio -dumpl ${CD_DISC1}
969.endif
970 @cd ${RD}/dists && find . -print | cpio -dumpl ${CD_DISC1}/${BUILDNAME}
971.if !defined(NODOC)
972 @for i in ${DIST_DOCS_ARCH_INDEP}; do \
973 cp ${RND}/${RELNOTES_LANG}/$$i/article.txt \
974 ${CD_DISC1}/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
975 cp ${RND}/${RELNOTES_LANG}/$$i/article.html \
976 ${CD_DISC1}/`echo $${i} | tr 'a-z' 'A-Z'`.HTM; \
977 done
978 @for i in ${DIST_DOCS_ARCH_DEP}; do \
979 cp ${RND}/${RELNOTES_LANG}/$$i/${TARGET}/article.txt \
980 ${CD_DISC1}/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
981 cp ${RND}/${RELNOTES_LANG}/$$i/${TARGET}/article.html \
982 ${CD_DISC1}/`echo $${i} | tr 'a-z' 'A-Z'`.HTM; \
983 done
984 @cp ${RND}/${RELNOTES_LANG}/readme/docbook.css ${CD_DISC1}
985 @mv ${CD_DISC1}/INSTALLATION.TXT ${CD_DISC1}/INSTALL.TXT
986 @mv ${CD_DISC1}/INSTALLATION.HTM ${CD_DISC1}/INSTALL.HTM
987.endif
988.if defined(SEPARATE_LIVEFS)
989 @cp -Rp ${CD_LIVEFS}/boot ${CD_DISC1}
990 @echo "CD_VERSION = ${BUILDNAME}" > ${CD_DISC1}/cdrom.inf
991.endif
992 @echo "CD_VOLUME = 1" >> ${CD_DISC1}/cdrom.inf
993 @echo "Building CDROM disc2 filesystem image"
994 @mkdir -p ${CD_DISC2}
995 @echo "CD_VERSION = ${BUILDNAME}" > ${CD_DISC2}/cdrom.inf
996 @echo "CD_VOLUME = 2" >> ${CD_DISC2}/cdrom.inf
997.if !defined(NODOC)
998 @mkdir -p ${CD_DISC2}/usr/share/doc
999 @for i in `ls ${CD_LIVEFS}/usr/share/doc`; do \
1000 if [ -L ${CD_LIVEFS}/usr/share/doc/$$i -o \
1001 -d /usr/doc/$$i ]; then \
1002 mv ${CD_LIVEFS}/usr/share/doc/$$i \
1003 ${CD_DISC2}/usr/share/doc; \
1004 fi \
1005 done
1006.endif
1007 touch ${.TARGET}
1008
1009#
1010# --==## Setup a suitable cdrom-area ##==--
1011#
1012cdrom.3:
1013.if defined(CD_BOOT)
1014 @echo "Building bootonly CDROM filesystem image"
1015 @mkdir -p ${CD_BOOT}
1016 @cp -Rp ${CD_LIVEFS}/boot ${CD_BOOT}
1017 @echo "CD_VERSION = ${BUILDNAME}" > ${CD_BOOT}/cdrom.inf
1018.if defined(MINIROOT)
1019 @echo "Building bootonly UFS filesystem image"
1020 @mkdir -p ${FD}/miniroot
1021 @sh -e ${DOFS_SH} ${FD}/miniroot/miniroot.ufs \
1022 ${RD} ${MNT} 0 ${CD_BOOT} 8192 auto
1023 @gzip -9v ${FD}/miniroot/miniroot.ufs
1024.endif
1025.endif
1026 touch ${.TARGET}
1027
1028.if make(iso.1)
1029.if defined(CD_PACKAGE_TREE)
1030.if exists(${CD_PACKAGE_TREE}/disc1)
1031CD_DISC1_PKGS= ${CD_PACKAGE_TREE}/disc1
1032.endif
1033.if exists(${CD_PACKAGE_TREE}/disc2)
1034CD_DISC2_PKGS= ${CD_PACKAGE_TREE}/disc2
1035.endif
1036.endif
1037.endif
1038
1039iso.1:
1040.if exists(${.CURDIR}/${TARGET_ARCH}/mkisoimages.sh)
1041 @echo "Creating ISO images..."
1042.if defined(CD_BOOT)
1043 @sh ${.CURDIR}/${TARGET_ARCH}/mkisoimages.sh ${BOOTABLE} \
1044 FreeBSD_bootonly \
1045 ${CD}/${BUILDNAME}-${TARGET}-bootonly.iso ${CD_BOOT}
1046.endif
1047 @sh ${.CURDIR}/${TARGET_ARCH}/mkisoimages.sh ${BOOTABLE} \
1048 FreeBSD_Install \
1049 ${CD}/${BUILDNAME}-${TARGET}-disc1.iso ${CD_DISC1} \
1050 ${CD_DISC1_PKGS}
1051 @sh ${.CURDIR}/${TARGET_ARCH}/mkisoimages.sh \
1052 FreeBSD_Packages \
1053 ${CD}/${BUILDNAME}-${TARGET}-disc2.iso ${CD_DISC2} \
1054 ${CD_DISC2_PKGS}
1055.if defined(SEPARATE_LIVEFS)
1056 @sh ${.CURDIR}/${TARGET_ARCH}/mkisoimages.sh ${BOOTABLE} \
1057 FreeBSD_LiveFS \
1058 ${CD}/${BUILDNAME}-${TARGET}-livefs.iso ${CD_LIVEFS}
1059.endif
1060 @echo "Generating MD5 and SHA256 sums..."
1061 @(cd ${CD} && md5 *.iso > ${BUILDNAME}-${TARGET}-iso.CHECKSUM.MD5)
1062 @(cd ${CD} && sha256 *.iso > ${BUILDNAME}-${TARGET}-iso.CHECKSUM.SHA256)
1063 touch ${.TARGET}
1064.else
1065 @echo "Do not know how to create an ISO for ${TARGET_ARCH}."
1066.endif
1067
1068#
1069# --==## Documentation Project files such as the Handbook and FAQ ##==--
1070#
1071doc.1:
1072 @echo "Making docs..."
1073 @for i in ${DOCPORTS}; do \
1074 cd /usr/ports/$$i && \
1075 env -i FTP_PASSIVE_MODE=$${FTP_PASSIVE_MODE:-no} PATH=$${PATH} \
1076 make all install clean BATCH=yes WITHOUT_X11=yes JADETEX=no \
1077 WITHOUT_PYTHON=yes FORCE_PKG_REGISTER=yes; \
1078 done
1079 @cd /usr/doc && make all install 'FORMATS=html html-split txt' \
1080 INSTALL_COMPRESSED='' DOCDIR=${RD}/trees/base/usr/share/doc \
1081 URLS_ABSOLUTE=YES
1082 touch ${.TARGET}
1083
1084#
1085# --==## RELNOTESng: Next-generation replacements for *.TXT files ##==--
1086#
1087doc.2:
1088 @echo "Making release documentation..."
1089 @cd ${.CURDIR}/doc && make all install clean 'FORMATS=html txt' \
1090 INSTALL_COMPRESSED='' URLS_ABSOLUTE=YES DOCDIR=${RND}
1091 touch ${.TARGET}
1092
1093# Various "subroutine" and other supporting targets.
1094
1095# RD=
1096# SD=
1097# TD=
1098# ARG=
1099doTARBALL:
1100.if !defined(SD)
1101 @echo "SD undefined in doTARBALL" && exit 1
1102.endif
1103.if !defined(TD)
1104 @echo "TD undefined in doTARBALL" && exit 1
1105.endif
1106.if !defined(ARG)
1107 @echo "ARG undefined in doTARBALL" && exit 1
1108.endif
1109 @rm -rf ${RD}/dists/${TD}/${TN}*
1110 @mkdir -p ${RD}/dists/${TD}
1111 @( cd ${SD} && \
1112 tn=`echo ${TN} | tr 'A-Z' 'a-z' | cut -c1-8` && \
1113 echo rolling ${TD}/$$tn tarball &&\
1114 tar --exclude CVS --exclude obj --exclude BOOTMFS -cf - ${ARG} | \
1115 ${ZIPNSPLIT} ${RD}/dists/${TD}/$$tn. && \
1116 sh ${.CURDIR}/scripts/info.sh ${RD}/dists/${TD}/$$tn \
1117 > ${RD}/dists/${TD}/$$tn.inf && \
1118 if [ -f ${.CURDIR}/scripts/$${TD}-install.sh ]; then \
1119 cp -p ${.CURDIR}/scripts/$${TD}-install.sh \
1120 ${RD}/dists/${TD}/install.sh; \
1121 fi && \
1122 if [ "${SD}" != "/usr/src" ]; then \
1123 mtree -c -i -p ${SD}/${ARG} \
1124 -k gname,md5digest,mode,nlink,uname,size,link,type \
1125 > ${RD}/dists/${TD}/$$tn.mtree ; \
1126 else \
1127 true; \
1128 fi; \
1129 ( cd ${RD}/dists/${TD}; \
1130 rm -f CHECKSUM.MD5 CHECKSUM.SHA256; \
1131 md5 * > .CHECKSUM.MD5; \
1132 sha256 * > .CHECKSUM.SHA256; \
1133 mv .CHECKSUM.MD5 CHECKSUM.MD5; \
1134 mv .CHECKSUM.SHA256 CHECKSUM.SHA256) \
1135 )
1136
1137doRELEASE: release.1 release.2 ${DOCREL} release.3 release.4 \
1138 release.5 release.6 release.7 release.8 ${EXTRAS}
1139 @echo "Release done"
1140
1141floppies:
1142 @rm -f release.4 release.8 floppies.[123]
1143 @cd ${.CURDIR} && ${MAKE} release.4 release.8 floppies.1 floppies.2 \
1144 floppies.3
1145 @cd ${RD} && find floppies -print | cpio -dumpl ${FD}
1146
1147installCRUNCH:
1148.if !defined(CRUNCH)
1149 @echo "CRUNCH undefined in installCRUNCH" && exit 1
1150.endif
1151.if !defined(DIR)
1152 @echo "DIR undefined in installCRUNCH" && exit 1
1153.endif
1154.if !defined(ZIP)
1155 @echo "ZIP undefined in installCRUNCH" && exit 1
1156.endif
1157 @if ${ZIP} ; then \
1158 gzip -9 < ${RD}/crunch/${CRUNCH} > ${DIR}/${CRUNCH}_crunch ; \
1159 else \
1160 ln -f ${RD}/crunch/${CRUNCH} ${DIR}/${CRUNCH}_crunch ; \
1161 fi
1162 @chmod 555 ${DIR}/${CRUNCH}_crunch
1163 @if [ -f ${.CURDIR}/${TARGET}/${CRUNCH}_crunch.conf ] ; then \
1164 for i in `crunchgen -l ${.CURDIR}/${TARGET}/${CRUNCH}_crunch.conf` ; do \
1165 ln -f ${DIR}/${CRUNCH}_crunch ${DIR}/$$i ; \
1166 done \
1167 else \
1168 for i in `crunchgen -l ${.CURDIR}/${CRUNCH}_crunch.conf` ; do \
1169 ln -f ${DIR}/${CRUNCH}_crunch ${DIR}/$$i ; \
1170 done \
1171 fi
1172
1173#
1174# --==## Build a floppy set for a splitfs file ##==--
1175#
1176# FLOPPYBASE - basename of floppy image files
1177# FLOPPYDESC - description of floppy set
1178# SPLITFILE - filename of the file to split
1179# FDSIZE - if specified and "small", small floppy is created
1180
1181.if make(makeFloppySet)
1182SPLITDIR= ${RD}/floppyset/${FLOPPYBASE}
1183.if defined(FDSIZE) && ${FDSIZE} == "SMALL"
1184FLPSPLITSIZE= ${SMALLFLOPPYSPLITSIZE}
1185FLPSIZE= ${SMALLFLOPPYSIZE}
1186FLPLABEL= ${SMALLFLOPPYLABEL}
1187.else
1188FLPSPLITSIZE= ${FLOPPYSPLITSIZE}
1189FLPSIZE= ${FLOPPYSIZE}
1190FLPLABEL= ${FLOPPYLABEL}
1191.endif
1192.endif
1193
1194makeFloppySet:
1195.if !defined(FLOPPYBASE)
1196 @echo "FLOPPYBASE undefined in ${.TARGET}" && exit 1
1197.endif
1198.if !defined(FLOPPYDESC)
1199 @echo "FLOPPYDESC undefined in ${.TARGET}" && exit 1
1200.endif
1201.if !defined(SPLITFILE)
1202 @echo "SPLITFILE undefined in ${.TARGET}" && exit 1
1203.endif
1204 sh ${.CURDIR}/scripts/split-file.sh ${SPLITFILE} \
1205 ${RD}/floppyset/${FLOPPYBASE} ${FLPSPLITSIZE} "${FLOPPYDESC}"
1206 ( splitfile=${SPLITDIR}/`basename ${SPLITFILE}`.split ; \
1207 lines=`cat $${splitfile} | wc -l`; \
1208 lines=$$(($$lines - 1)) ; \
1209 for line in `jot $$lines`; do \
1210 file=`head -n $$(($${line} + 1)) $${splitfile} | tail -1 | cut -f 1 -d ' '` ; \
1211 sh -e ${DOFS_SH} ${RD}/floppies/${FLOPPYBASE}$${line}.flp \
1212 ${RD} ${MNT} ${FLPSIZE} ${SPLITDIR}/$${file} \
1213 ${BOOTINODE} ${FLPLABEL}; \
1214 done )
1215
1216#
1217# --==## Build a boot floppy ##==--
1218#
1219# FSIMAGE - base floppy image name
1220# FDSIZE - if specified and "small", small floppy is created
1221# KERNFILE - path to kernel split file
1222# MFSROOTFILE - path to mfsroot split file
1223
1224.if make(buildBootFloppy)
1225IMAGEDIR= ${RD}/image.${FSIMAGE}
1226BOOTDIR= ${RD}/trees/base/boot
1227HINTSFILE= ${BOOTDIR}/device.hints
1228ACPI_KO= ${BOOTDIR}/kernel/acpi.ko
1229IMAGEFILE= ${RD}/floppies/${FSIMAGE}.flp
1230.if defined(FDSIZE) && ${FDSIZE} == "SMALL"
1231FLPSIZE= ${SMALLFLOPPYSIZE}
1232FLPLABEL= ${SMALLFLOPPYLABEL}
1233.else
1234FLPSIZE= ${FLOPPYSIZE}
1235FLPLABEL= ${FLOPPYLABEL}
1236.endif
1237.endif
1238
1239buildBootFloppy:
1240.if !defined(FSIMAGE)
1241 @echo "FSIMAGE undefined in ${.TARGET}" && exit 1
1242.endif
1243.if !defined(KERNFILE)
1244 @echo "KERNFILE undefined in ${.TARGET}" && exit 1
1245.endif
1246.if !defined(MFSROOTFILE)
1247 @echo "MFSROOTFILE undefined in ${.TARGET}" && exit 1
1248.endif
1249 @echo "Running ${.TARGET} for ${FSIMAGE}"
1250 @rm -rf ${IMAGEDIR}
1251 @mkdir ${IMAGEDIR}
1252 @echo "Setting up /boot directory for ${FSIMAGE} floppy"
1253 @mkdir -p ${IMAGEDIR}/boot
1254.if ${TARGET} == "i386"
1255 @${WMAKEENV} kgzip -v -l ${RD}/trees/base/usr/lib/kgzldr.o -o \
1256 ${IMAGEDIR}/boot/loader ${BOOTDIR}/loader
1257.else
1258 @cp ${BOOTDIR}/loader ${IMAGEDIR}/boot
1259.endif
1260 @cp -Rp ${BOOTDIR}/*.4th ${BOOTDIR}/defaults ${BOOTDIR}/loader.help \
1261 ${BOOTDIR}/loader.rc ${IMAGEDIR}/boot
1262.if exists(${HINTSFILE})
1263 @cp ${HINTSFILE} ${IMAGEDIR}/boot/device.hints
1264.if ${TARGET} == "i386" || ${TARGET_ARCH} == "amd64"
1265 @echo 'hint.atkbd.0.flags="0x1"' >> ${IMAGEDIR}/boot/device.hints
1266.endif
1267 @gzip -9n ${IMAGEDIR}/boot/device.hints
1268.endif
1269 @gzip -9n ${IMAGEDIR}/boot/*.4th ${IMAGEDIR}/boot/loader.help \
1270 ${IMAGEDIR}/boot/defaults/loader.conf
1271 @echo 'bootfile="/kernel"' > ${IMAGEDIR}/boot/loader.conf
1272.if exists(${ACPI_KO})
1273 @gzip -9nc ${ACPI_KO} > ${IMAGEDIR}/acpi.ko.gz
1274 @echo 'acpi_load="YES"' >> ${IMAGEDIR}/boot/loader.conf
1275 @echo 'acpi_name="/acpi.ko"' >> ${IMAGEDIR}/boot/loader.conf
1276 @echo 'acpi_before="read -p \"Insert boot floppy and press Enter\""' >> ${IMAGEDIR}/boot/loader.conf
1277.endif
1278 @echo 'mfsroot_load="YES"' >> ${IMAGEDIR}/boot/loader.conf
1279 @echo 'mfsroot_type="mfs_root"' >> ${IMAGEDIR}/boot/loader.conf
1280 @echo 'mfsroot_name="/mfsroot"' >> ${IMAGEDIR}/boot/loader.conf
1281.if !exists(${ACPI_KO})
1282 @echo 'mfsroot_before="read -p \"Insert boot floppy and press Enter\""' >> ${IMAGEDIR}/boot/loader.conf
1283.endif
1284.if defined(SPLIT_MFSROOT)
1285 @echo 'mfsroot_after="read -p \"Insert boot floppy and press Enter\""' >> ${IMAGEDIR}/boot/loader.conf
1286.endif
1287.if ${TARGET_ARCH} == "i386" && ${AUTO_KEYBOARD_DETECT}
1288 @echo "-P" >> ${IMAGEDIR}/boot.config
1289.endif
1290 @rm -f ${IMAGEFILE}
1291 @cp ${KERNFILE} ${MFSROOTFILE} ${IMAGEDIR}
1292 sh -e ${DOFS_SH} ${IMAGEFILE} ${RD} ${MNT} ${FLPSIZE} ${IMAGEDIR} \
1293 ${BOOTINODE} ${FLPLABEL}
1294 @echo "Created ${RD}/floppies/${FSIMAGE}.flp"
1295
1296.if make(package-split)
1297# Targets related to making a package split
1298#
1299# PKG_COPY instructs the script to copy the actual package files rather than
1300# make hard links
1301# PKG_TREE is the path to the package tree to be split
1302# PKG_DEST is the path to the destination tree to create the split in
1303# PKG_VERBOSE asks for verbose output of the layout process
1304# PKG_INDEX is the path to the INDEX file. By default ${PKG_TREE}/INDEX.
1305
1306.if defined(PKG_COPY)
1307PKG_DO_COPY= cp
1308.else
1309PKG_DO_COPY= ln
1310.endif
1311PKG_WRKIDX= ${PKG_DEST}/INDEX.master
1312PKG_ENV?=
1313.if defined(TARGET_ARCH)
1314PKG_ENV+= PKG_ARCH=${TARGET_ARCH}
1315.endif
1316.if defined(PKG_VERBOSE)
1317PKG_ENV+= PKG_VERBOSE=1
1318.endif
1319PKG_INDEX?= ${PKG_TREE}/INDEX
1320
1321package-split:
1322.if !defined(PKG_TREE)
1323 @echo "PKG_TREE must be defined" && exit 1
1324.endif
1325.if !defined(PKG_DEST)
1326 @echo "PKG_DEST must be defined" && exit 1
1327.endif
1328 @env ${PKG_ENV} python ${.CURDIR}/scripts/package-split.py \
1329 ${PKG_INDEX} ${PKG_WRKIDX}
1330 @env ${PKG_ENV} sh ${.CURDIR}/scripts/package-trees.sh ${PKG_DO_COPY} \
1331 ${PKG_WRKIDX} ${PKG_TREE} ${PKG_DEST}
1332.endif
1333
1334.include <bsd.obj.mk>
380 cd ${WORLDDIR} && ${NATIVEMAKE} distribution DESTDIR=${CHROOTDIR}
381 if [ -f /etc/resolv.conf ]; then \
382 cp -p /etc/resolv.conf ${CHROOTDIR}/etc; \
383 fi
384.if defined(EXTLOCALDIR)
385 rm -rf ${CHROOTDIR}/usr/local
386 cd ${CHROOTDIR}/usr && cp -R -H ${EXTLOCALDIR} local
387.endif
388 rm -rf ${CHROOTDIR}/usr/src
389.if defined(EXTSRCDIR)
390 cd ${CHROOTDIR}/usr && \
391 cp -R -H ${EXTSRCDIR} src
392.else
393 cd ${CHROOTDIR}/usr && \
394 ${CVSPREFIX} cvs -R ${CVSARGS} -d ${CVSROOT} \
395 co ${CVSCMDARGS} ${CVS_SRCARGS} ${RELEASESRCMODULE}
396.endif
397.if defined(LOCAL_PATCHES) && !empty(LOCAL_PATCHES)
398.for p in ${LOCAL_PATCHES}
399 patch -d ${CHROOTDIR}/usr/${RELEASESRCMODULE} ${PATCH_FLAGS} < ${p}
400.endfor
401.endif
402.if defined(LOCAL_SCRIPT)
403 cd ${CHROOTDIR} && env CHROOTDIR=${CHROOTDIR} BUILDNAME=${BUILDNAME} \
404 RELEASETAG=${RELEASETAG} ${LOCAL_SCRIPT}
405.endif
406 rm -rf ${CHROOTDIR}/usr/ports
407.if !defined(NOPORTSATALL)
408.if defined(EXTPORTSDIR)
409 cd ${CHROOTDIR}/usr && cp -R -H ${EXTPORTSDIR} ports
410 # If there are distfiles downloaded removing them
411 rm -rf ports/distfiles/*
412.else
413 cd ${CHROOTDIR}/usr && ${CVSPREFIX} cvs -R ${CVSARGS} -d ${CVSROOT} \
414 co ${CVSCMDARGS} ${CVS_PORTSARGS} ${RELEASEPORTSMODULE}
415.endif
416.endif
417.if !defined(NODOC)
418 rm -rf ${CHROOTDIR}/usr/doc
419.if defined(EXTDOCDIR)
420 cd ${CHROOTDIR}/usr && cp -R -H ${EXTDOCDIR} doc
421.else
422 cd ${CHROOTDIR}/usr && ${CVSPREFIX} cvs -R ${CVSARGS} -d ${CVSROOT} \
423 co ${CVSCMDARGS} ${CVS_DOCARGS} ${RELEASEDOCMODULE}
424.endif
425 if [ -d ${RELEASEDISTFILES}/ ]; then \
426 cp -rp ${RELEASEDISTFILES} ${CHROOTDIR}/usr/ports/distfiles; \
427 else \
428 mkdir -p ${CHROOTDIR}/usr/ports/distfiles; \
429 fi
430.if !defined(NO_PREFETCHDISTFILES)
431 @cd ${.CURDIR} && ${MAKE} fetch-distfiles
432.endif
433.endif
434.endif
435.if make(rerelease)
436.if !defined(RELEASENOUPDATE)
437.if !defined(RELEASETAG)
438 cd ${CHROOTDIR}/usr/src && ${CVSPREFIX} cvs -R ${CVSARGS} -q \
439 update ${CVSCMDARGS} -P -d -A
440.else
441 cd ${CHROOTDIR}/usr/src && ${CVSPREFIX} cvs -R ${CVSARGS} -q \
442 update ${CVSCMDARGS} -P -d -r ${RELEASETAG}
443.endif
444 rm -f ${CHROOTDIR}/tmp/.world_done
445.if !defined(NOPORTS) && !defined(EXTPORTSDIR)
446 cd ${CHROOTDIR}/usr/ports && ${CVSPREFIX} cvs -R ${CVSARGS} -q \
447 update ${CVSCMDARGS} -P -d
448 rm -f ${CHROOTDIR}/tmp/.skip_ports_index
449.endif
450.if defined(DOMINIMALDOCPORTS) && ${DOMINIMALDOCPORTS} == "YES"
451 for i in ${MINIMALDOCPORTS}; do \
452 ( cd ${CHROOTDIR}/usr/$$i && ${CVSPREFIX} cvs -R ${CVSARGS} -q \
453 update ${CVSCMDARGS} -P -d ) ; \
454 done
455.endif
456.if !defined(NODOC)
457 cd ${CHROOTDIR}/usr/doc && ${CVSPREFIX} cvs -R ${CVSARGS} -q \
458 update ${CVSCMDARGS} -P -d
459.endif
460.endif
461.endif
462 # Add version information to those things that need it.
463 if [ ! -f ${CHROOTDIR}/tmp/.world_done ]; then \
464 cd ${CHROOTDIR}/usr/src/sys/conf && \
465 mv newvers.sh foo && \
466 sed "s/^RELEASE=.*/RELEASE=${BUILDNAME}/" foo > newvers.sh && \
467 rm foo; \
468 fi
469 -test -f install.cfg && cp install.cfg ${CHROOTDIR}/usr/src/release
470 echo "#!/bin/sh" > ${_MK}
471 echo "set -ex" >> ${_MK}
472 echo "trap 'umount /dev || true' 0" >> ${_MK}
473 echo "_RELTARGET=\$${1:-doRELEASE}" >> ${_MK}
474.for var in \
475 AUTO_KEYBOARD_DETECT \
476 BUILDNAME \
477 CD_PACKAGE_TREE \
478 DISTRIBUTIONS \
479 DOC_LANG \
480 DOMINIMALDOCPORTS \
481 EXTRA_SRC \
482 FTP_PASSIVE_MODE \
483 FTP_PROXY \
484 HTTP_PROXY \
485 KERNELS \
486 KERNELS_BASE \
487 KERNEL_FLAGS \
488 MAKE_FLOPPIES \
489 MAKE_ISOS \
490 NOCDROM \
491 NODOC \
492 NOPORTS \
493 NO_SHARED \
494 NOSRC \
495 NO_CPU_CFLAGS \
496 NO_CPU_COPTFLAGS \
497 NO_FLOPPIES \
498 RELEASETAG \
499 RELNOTES_LANG \
500 SEPARATE_LIVEFS \
501 TARGET \
502 TARGET_ARCH \
503 WORLD_FLAGS
504.if defined(${var})
505 echo "export ${var}=\"${${var}}\"" >> ${_MK}
506.endif
507.endfor
508 # Don't remove this, or the build will fall over!
509 echo "export RELEASEDIR=${_R}" >> ${_MK}
510 echo "export PATH=/bin:/usr/bin:/sbin:/usr/sbin:${LOCALDIR}" >> ${_MK}
511 echo "export MANBUILDCAT=YES" >> ${_MK}
512 # NB: these may fail if the host is running w/o devfs
513 echo "umount /dev >/dev/null 2>&1 || true" >> ${_MK}
514 echo "mount -t devfs devfs /dev >/dev/null 2>&1 || true" >> ${_MK}
515 echo "if [ -x /etc/rc.d/ldconfig ]; then" >> ${_MK}
516 echo " /etc/rc.d/ldconfig start" >> ${_MK}
517 echo "else" >> ${_MK}
518 echo " ldconfig /lib /usr/lib /usr/local/lib || true" >> ${_MK}
519 echo "fi" >> ${_MK}
520 echo "if [ ! -f /tmp/.world_done ]; then" >> ${_MK}
521 echo " cd /usr/src" >> ${_MK}
522 echo " ${CROSSMAKE} ${WORLD_FLAGS} -DNO_CLEAN buildworld && \\" >> ${_MK}
523 echo " touch /tmp/.world_done || exit 1" >> ${_MK}
524 echo "fi" >> ${_MK}
525 echo "if [ ! -f /tmp/.skip_ports_index ]; then" >> ${_MK}
526 echo " echo \">>> make index started on \`LC_ALL=C TZ=GMT date\`\"" >> ${_MK}
527 echo " for i in ${MAKEINDEXPORTS}" >> ${_MK}
528 echo " do" >> ${_MK}
529 echo " cd /usr/ports/\$${i}" >> ${_MK}
530 echo " env -i FTP_PASSIVE_MODE=$${FTP_PASSIVE_MODE:-no} PATH=$${PATH} \\" >> ${_MK}
531 echo " make all install clean BATCH=yes FORCE_PKG_REGISTER=yes" >> ${_MK}
532 echo " done" >> ${_MK}
533 echo " cd /usr/ports" >> ${_MK}
534 echo " rm -f INDEX*" >> ${_MK}
535 echo " make index -DINDEX_PRISTINE" >> ${_MK}
536 echo " rm -f INDEX*.tmp" >> ${_MK}
537 echo " touch /tmp/.skip_ports_index" >> ${_MK}
538 echo " echo \">>> make index finished on \`LC_ALL=C TZ=GMT date\`\"" >> ${_MK}
539 echo "fi" >> ${_MK}
540 echo "cd /usr/src/release" >> ${_MK}
541 echo "make obj" >> ${_MK}
542 echo "make \$${_RELTARGET}" >> ${_MK}
543 echo "echo \">>> make ${.TARGET} for ${TARGET} finished on \`LC_ALL=C TZ=GMT date\`\"" >> ${_MK}
544 chmod 755 ${_MK}
545.if defined(NOPORTS)
546 touch ${CHROOTDIR}/tmp/.skip_ports_index
547.endif
548 # Ensure md.ko is loaded if md(4) is not statically compiled into
549 # the kernel
550 -mdconfig 2>/dev/null
551 env -i /usr/sbin/chroot `dirname ${_MK}` /`basename ${_MK}`
552
553clean:
554 rm -rf ${CRUNCH_TARGETS:S/$/_crunch/} release.[0-8] ${EXTRAS}
555
556fetch-distfiles:
557 @for i in ${MAKEINDEXPORTS}; do \
558 cd ${CHROOTDIR}/usr/ports/$$i && \
559 make PORTSDIR=${CHROOTDIR}/usr/ports BATCH=yes \
560 checksum-recursive ; \
561 done
562 @for i in ${DOCPORTS}; do \
563 cd ${CHROOTDIR}/usr/ports/$$i && \
564 make PORTSDIR=${CHROOTDIR}/usr/ports BATCH=yes \
565 WITHOUT_X11=yes JADETEX=no WITHOUT_PYTHON=yes \
566 checksum-recursive ; \
567 done
568
569# Clean out ${_R} and make the directory structure.
570release.1:
571 mkdir -p ${_R}
572 -rm -rf ${_R}/* 2> /dev/null
573 -chflags -R noschg ${_R}/.
574 rm -rf ${_R}/*
575 mkdir ${RD}
576.if defined(MAKE_FLOPPIES)
577 mkdir ${RD}/floppies
578.endif
579 mkdir ${RD}/trees
580 for i in ${DISTRIBUTIONS}; do \
581 mkdir ${RD}/trees/$$i && \
582 mtree -deU -f ${MTREEFILES}/BSD.root.dist \
583 -p ${RD}/trees/$$i > /dev/null && \
584 mtree -deU -f ${MTREEFILES}/BSD.usr.dist \
585 -p ${RD}/trees/$$i/usr > /dev/null && \
586 mtree -deU -f ${MTREEFILES}/BSD.include.dist \
587 -p ${RD}/trees/$$i/usr/include > /dev/null && \
588 mtree -deU -f ${MTREEFILES}/BSD.var.dist \
589 -p ${RD}/trees/$$i/var > /dev/null ; \
590 done
591 mkdir ${RD}/kernels
592 for i in ${KERNELS_BASE} ${KERNELS}; do \
593 mkdir -p ${RD}/kernels/$${i}; \
594 done
595 touch ${.TARGET}
596
597# Install the system into the various distributions.
598release.2:
599 cd ${.CURDIR}/../etc && make distrib-dirs DESTDIR=${RD}/trees/base
600 cd ${.CURDIR}/.. && ${CROSSMAKE} ${WORLD_FLAGS} distributeworld \
601 DISTDIR=${RD}/trees
602 touch ${.TARGET}
603
604# Make and install the generic kernel(s).
605release.3:
606.for kernel in ${KERNELS_BASE} ${KERNELS}
607 cd ${.CURDIR}/..; \
608 ${CROSSMAKE} ${KERNEL_FLAGS} \
609 KERNCONF=${kernel} kernel \
610 DESTDIR=${RD}/kernels KODIR=/${kernel}
611.endfor
612 touch ${.TARGET}
613
614# Make and install the three crunched binaries which live on the floppies.
615# You are not supposed to like this :-)
616release.4:
617 rm -rf ${RD}/crunch
618 mkdir -p ${RD}/crunch
619.for j in ${CRUNCH_TARGETS}
620.if exists(${.CURDIR}/${TARGET}/${j}_crunch.conf)
621 rm -rf ${j}_crunch
622 mkdir ${j}_crunch
623 cd ${j}_crunch; ${WMAKEENV} crunchgen -o \
624 ${.CURDIR}/${TARGET}/${j}_crunch.conf
625 cd ${j}_crunch; ${WMAKE} -f ${j}_crunch.mk subclean
626 cd ${.CURDIR}/..; ${BINMAKE} -f Makefile.inc1 _build-tools
627 cd ${j}_crunch; CFLAGS="-Os -pipe" ${WMAKE} -f ${j}_crunch.mk \
628 -DNO_CPU_CFLAGS all
629 ${WMAKEENV} strip -R .comment ${j}_crunch/${j}_crunch
630 mv ${j}_crunch/${j}_crunch ${RD}/crunch/${j}
631.endif
632.endfor
633 touch ${.TARGET}
634
635#
636# --==## Fix up the distributions. ##==--
637#
638release.5:
639 # Create any "synthetic dists" now.
640 @for i in ${DISTRIBUTIONS}; do \
641 if [ -f ${.CURDIR}/scripts/$${i}-make.sh ]; then \
642 echo -n "Running $$i dist creation script... "; \
643 env RD=${RD} sh ${.CURDIR}/scripts/$${i}-make.sh || echo "$$i distribution script returned bad status."; \
644 echo "Done."; \
645 fi \
646 done \
647
648 # Remove all the directories we don't need.
649 -cd ${RD}/trees && \
650 (find ${OTHER_DISTS} -path '*/var/empty' | xargs chflags noschg; \
651 find ${OTHER_DISTS} -depth -type d -print | xargs rmdir)
652 touch ${.TARGET}
653
654#
655# --==## Package up the tarballs from assembled trees ##==--
656#
657release.6:
658 rm -rf ${RD}/dists
659 mkdir -p ${RD}/dists
660 @for i in ${DISTRIBUTIONS} ; \
661 do \
662 if [ -d ${RD}/trees/$${i} ] ; then \
663 cd ${.CURDIR} && $(MAKE) doTARBALL \
664 SD=${RD}/trees/$${i} \
665 TN=$$i TD=$$i ARG="." && \
666 echo "$${i} distribution is finished."; \
667 fi ; \
668 done
669 @for i in ${KERNELS_BASE} ${KERNELS} ; \
670 do \
671 if [ -d ${RD}/kernels/$${i} ] ; then \
672 cd ${.CURDIR} && $(MAKE) doTARBALL \
673 SD=${RD}/kernels \
674 TN=$$i TD=kernels ARG="$$i" && \
675 echo "$${i} distribution is finished."; \
676 fi ; \
677 done
678.if !defined(NOPORTS)
679 # XXX: Inline stripped version of doTARBALL
680 @rm -rf ${RD}/dists/ports/ports*
681 @mkdir -p ${RD}/dists/ports
682 @echo rolling ports/ports tarball
683 @tar --exclude CVS --exclude 'ports/distfiles/*' \
684 -czf ${RD}/dists/ports/ports.tgz -C /usr ports
685 @cp ${.CURDIR}/scripts/ports-install.sh ${RD}/dists/ports/install.sh
686 @(cd ${RD}/dists/ports; \
687 rm -f CHECKSUM.MD5 CHECKSUM.SHA256; \
688 md5 * > .CHECKSUM.MD5; \
689 sha256 * > .CHECKSUM.SHA256; \
690 mv .CHECKSUM.MD5 CHECKSUM.MD5; \
691 mv .CHECKSUM.SHA256 CHECKSUM.SHA256)
692 @echo "ports distribution is finished."
693.endif
694 touch ${.TARGET}
695
696
697#
698# --==## Make source dists ##==--
699#
700release.7:
701.if !defined(NOSRC)
702 @cd ${.CURDIR} && $(MAKE) doTARBALL SD=/usr/src \
703 TD=src TN=sbase ARG="[A-Z]*"
704 @for i in `cd /usr/src && echo [a-z]*` ; do \
705 if [ -d /usr/src/$$i ] ; then \
706 cd ${.CURDIR} && $(MAKE) doTARBALL \
707 TN=`echo s$$i | tr -d '.' | \
708 sed -e 's/usr/u/' \
709 -e 's/kerberos5/krb5/'` \
710 SD=/usr/src TD=src ARG="$$i" ; \
711 fi ; \
712 done
713.if defined(EXTRA_SRC)
714 @set ${EXTRA_SRC} && \
715 while [ $$# -ge 2 ] ; do \
716 if [ -d /usr/src/$$1 ] ; then \
717 cd ${.CURDIR} && $(MAKE) doTARBALL \
718 SD=/usr/src TN="s$$2" TD=src ARG="$$1" ; \
719 fi && shift && shift ; \
720 done
721.endif
722 (cd ${RD}/dists/src; \
723 rm -f CHECKSUM.MD5 CHECKSUM.SHA256; \
724 md5 * > .CHECKSUM.MD5; \
725 sha256 * > .CHECKSUM.SHA256; \
726 mv .CHECKSUM.MD5 CHECKSUM.MD5; \
727 mv .CHECKSUM.SHA256 CHECKSUM.SHA256)
728 @echo "src distribution is finished."
729.endif
730 touch ${.TARGET}
731
732# Build the memory root filesystem.
733release.8:
734 cp ${RD}/trees/base/etc/disktab /etc
735 rm -rf ${RD}/mfsfd
736 mkdir ${RD}/mfsfd
737 cd ${RD}/mfsfd && \
738 mkdir -p etc/defaults dev mnt stand/etc/defaults stand/help \
739 var/empty
740 @cd ${.CURDIR} && $(MAKE) installCRUNCH CRUNCH=boot \
741 DIR=${RD}/mfsfd/stand ZIP=false
742 ( cd ${RD}/mfsfd && \
743 for dir in bin sbin ; do \
744 ln -sf /stand $$dir; \
745 done )
746 cp ${RD}/trees/base/sbin/dhclient-script ${RD}/mfsfd/stand
747.if ${TARGET} == "pc98"
748 cp ${.CURDIR}/../etc/defaults/pccard.conf \
749 ${RD}/mfsfd/etc/defaults/pccard.conf
750.endif
751 cp ${.CURDIR}/../etc/master.passwd ${RD}/mfsfd/etc/master.passwd
752 cp ${RD}/trees/base/etc/*pwd.db ${RD}/mfsfd/etc/
753 ( for F in defaults/rc.conf netconfig protocols ; do \
754 sed -e '/^#.*$$/d' -e 's/[:space:]*#.*$$//g' \
755 ${RD}/trees/base/etc/$$F > ${RD}/mfsfd/stand/etc/$$F ; \
756 done )
757 grep -E '^(ftp|nameserver|domain|sunrpc|cmd|nfsd)[^-\w]' \
758 ${RD}/trees/base/etc/services | \
759 sed -e '/^#.*$$/d' -e 's/[:space:]*#.*$$//g' \
760 > ${RD}/mfsfd/stand/etc/services
761 grep 'operator' ${RD}/trees/base/etc/group \
762 > ${RD}/mfsfd/stand/etc/group
763 ln ${RD}/mfsfd/stand/etc/services ${RD}/mfsfd/etc/services
764 ln ${RD}/mfsfd/stand/etc/group ${RD}/mfsfd/etc/group
765 ln ${RD}/mfsfd/stand/etc/netconfig ${RD}/mfsfd/etc/netconfig
766 cp ${RD}/trees/base/COPYRIGHT ${RD}/mfsfd/stand/help/COPYRIGHT.hlp
767.if !defined(NODOC)
768 @for i in ${DIST_DOCS_ARCH_INDEP}; do \
769 cp ${RND}/${RELNOTES_LANG}/$$i/article.txt \
770 ${RD}/mfsfd/stand/help/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
771 done
772 @for i in ${DIST_DOCS_ARCH_DEP}; do \
773 cp ${RND}/${RELNOTES_LANG}/$$i/${TARGET}/article.txt \
774 ${RD}/mfsfd/stand/help/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
775 done
776 @mv ${RD}/mfsfd/stand/help/INSTALLATION.TXT \
777 ${RD}/mfsfd/stand/help/INSTALL.TXT
778.endif
779 -test -f ${.CURDIR}/install.cfg \
780 && cp ${.CURDIR}/install.cfg ${RD}/mfsfd
781 @mkdir -p ${RD}/mfsfd/boot
782.if ${TARGET_ARCH} != "ia64" && ${TARGET_ARCH} != "powerpc"
783 @cp ${RD}/trees/base/boot/boot* ${RD}/mfsfd/boot
784.endif
785.if ${TARGET} == "i386" || ${TARGET_ARCH} == "amd64"
786 @cp ${RD}/trees/base/boot/mbr ${RD}/mfsfd/boot
787.endif
788 @tar --exclude CVS -cf - -C ${.CURDIR}/../usr.sbin/sysinstall help | \
789 tar xf - -C ${RD}/mfsfd/stand
790 @mkdir -p ${RD}/mfsroot
791 sh -e ${DOFS_SH} ${RD}/mfsroot/mfsroot ${RD} ${MNT} \
792 ${MFSSIZE} ${RD}/mfsfd ${MFSINODE} ${MFSLABEL}
793 @gzip -9fnv ${RD}/mfsroot/mfsroot
794 touch ${.TARGET}
795
796KERNFLOPPYSET= ${RD}/floppyset/kern/kernel.gz
797.if defined(SMALLFLOPPYSIZE)
798SMALLKERNFLOPPYSET= ${RD}/floppyset/kern-small/kernel.gz
799.endif
800.if defined(SPLIT_MFSROOT)
801MFSROOTFLOPPYSET= ${RD}/floppyset/mfsroot/mfsroot.gz
802.if defined(SMALLFLOPPYSIZE)
803SMALLMFSROOTFLOPPYSET= ${RD}/floppyset/mfsroot-small/mfsroot.gz
804.endif
805.endif
806
807# Build boot and install floppies.
808floppies.1:
809 @gzip -9nc ${RD}/kernels/GENERIC/kernel > ${RD}/kernels/kernel.gz
810 @echo "Making the kernel boot floppies..."
811 @cd ${.CURDIR} && ${MAKE} makeFloppySet FLOPPYBASE=kern \
812 FLOPPYDESC="Kernel" SPLITFILE=${RD}/kernels/kernel.gz
813.if defined(SMALLFLOPPYSIZE)
814 @echo "Making the small kernel boot floppies..."
815 @cd ${.CURDIR} && ${MAKE} makeFloppySet FLOPPYBASE=kern-small \
816 FLOPPYDESC="Kernel" SPLITFILE=${RD}/kernels/kernel.gz \
817 FDSIZE="SMALL"
818.endif
819.if defined(SPLIT_MFSROOT)
820 @echo "Making the mfsroot boot floppies..."
821 @cd ${.CURDIR} && ${MAKE} makeFloppySet FLOPPYBASE=mfsroot \
822 FLOPPYDESC="Memory Filesystem" SPLITFILE=${RD}/mfsroot/mfsroot.gz
823.if defined(SMALLFLOPPYSIZE)
824 @echo "Making the small mfsroot boot floppies..."
825 @cd ${.CURDIR} && ${MAKE} makeFloppySet FLOPPYBASE=mfsroot-small \
826 FLOPPYDESC="Memory Filesystem" SPLITFILE=${RD}/mfsroot/mfsroot.gz \
827 FDSIZE="SMALL"
828.endif
829 @cd ${.CURDIR} && ${MAKE} buildBootFloppy FSIMAGE="boot" \
830 KERNFILE="${KERNFLOPPYSET}.split ${KERNFLOPPYSET}.boot" \
831 MFSROOTFILE="${MFSROOTFLOPPYSET}.split ${MFSROOTFLOPPYSET}.boot"
832.if defined(SMALLFLOPPYSIZE)
833 @cd ${.CURDIR} && ${MAKE} buildBootFloppy FSIMAGE="boot-small" \
834 KERNFILE="${SMALLKERNFLOPPYSET}.split ${SMALLKERNFLOPPYSET}.boot" \
835 MFSROOTFILE="${SMALLMFSROOTFLOPPYSET}.split ${SMALLMFSROOTFLOPPYSET}.boot" \
836 FDSIZE="SMALL"
837.endif
838.else # !SPLIT_MFSROOT
839 @cd ${.CURDIR} && ${MAKE} buildBootFloppy FSIMAGE="boot" \
840 KERNFILE="${KERNFLOPPYSET}.split ${KERNFLOPPYSET}.boot" \
841 MFSROOTFILE=${RD}/mfsroot/mfsroot.gz
842.if defined(SMALLFLOPPYSIZE)
843 @cd ${.CURDIR} && ${MAKE} buildBootFloppy FSIMAGE="boot-small" \
844 KERNFILE="${SMALLKERNFLOPPYSET}.split ${SMALLKERNFLOPPYSET}.boot" \
845 MFSROOTFILE=${RD}/mfsroot/mfsroot.gz \
846 FDSIZE="SMALL"
847.endif
848.endif # SPLIT_MFSROOT
849 touch ${.TARGET}
850
851# Build fixit floppy.
852floppies.2:
853 @echo "Making fixit floppy."
854 @rm -rf ${RD}/fixitfd
855 @mkdir ${RD}/fixitfd
856 @cd ${RD}/fixitfd && \
857 mkdir -p dev stand bin sbin etc mnt mnt1 mnt2 mnt3 mnt4 tmp \
858 usr/share/misc
859 @cp ${RD}/trees/base/etc/spwd.db ${RD}/trees/base/etc/group \
860 ${RD}/fixitfd/etc
861 @sed -e 's/#.*//' ${RD}/trees/base/etc/protocols \
862 > ${RD}/fixitfd/etc/protocols
863 @sed -e 's/#.*//' ${RD}/trees/base/usr/share/misc/scsi_modes \
864 > ${RD}/fixitfd/usr/share/misc/scsi_modes
865 @cp ${.CURDIR}/fixit.profile ${RD}/fixitfd/.profile
866 @cp ${.CURDIR}/fixit.services ${RD}/fixitfd/etc/services
867 @cp ${.CURDIR}/scripts/tar.sh ${RD}/fixitfd/stand/tar
868 @chmod 555 ${RD}/fixitfd/stand/tar
869.if defined(SMALLFLOPPYSIZE)
870 @cd ${.CURDIR} && ${MAKE} installCRUNCH CRUNCH=fixit-small \
871 DIR=${RD}/fixitfd/stand ZIP=false
872 @sh -e ${DOFS_SH} ${RD}/floppies/fixit-small.flp ${RD} ${MNT} \
873 ${SMALLFLOPPYSIZE} ${RD}/fixitfd ${FLOPPYINODE} ${SMALLFLOPPYLABEL}
874 @rm -rf ${RD}/fixitfd/stand
875 @mkdir ${RD}/fixitfd/stand
876.endif
877 @cd ${.CURDIR} && ${MAKE} installCRUNCH CRUNCH=fixit \
878 DIR=${RD}/fixitfd/stand ZIP=false
879 @sh -e ${DOFS_SH} ${RD}/floppies/fixit.flp ${RD} ${MNT} \
880 ${FLOPPYSIZE} ${RD}/fixitfd ${FLOPPYINODE} ${FLOPPYLABEL}
881 touch ${.TARGET}
882
883# Do our last minute floppies directory setup
884floppies.3:
885.if !defined(NODOC)
886 @cp ${RND}/${RELNOTES_LANG}/installation/${TARGET}/article.txt \
887 ${RD}/floppies/README.TXT
888 @(cd ${RD}/floppies; md5 README.TXT *.flp > CHECKSUM.MD5)
889 @(cd ${RD}/floppies; sha256 README.TXT *.flp > CHECKSUM.SHA256)
890.else
891 @(cd ${RD}/floppies; md5 *.flp > CHECKSUM.MD5)
892 @(cd ${RD}/floppies; sha256 *.flp > CHECKSUM.SHA256)
893.endif
894 touch ${.TARGET}
895
896#
897# --==## Setup a suitable ftp-area ##==--
898#
899ftp.1:
900 @echo "Setting up FTP distribution area"
901 @mkdir -p ${FD}
902 -@ln -s . ${FD}/${BUILDNAME}
903.if defined(MAKE_FLOPPIES)
904 @cd ${RD} && find floppies -print | cpio -dumpl ${FD}
905.endif
906 @cd ${RD}/dists && find . -print | cpio -dumpl ${FD}
907.if !defined(NODOC)
908 @for i in ${DIST_DOCS_ARCH_INDEP}; do \
909 cp ${RND}/${RELNOTES_LANG}/$$i/article.txt \
910 ${FD}/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
911 cp ${RND}/${RELNOTES_LANG}/$$i/article.html \
912 ${FD}/`echo $${i} | tr 'a-z' 'A-Z'`.HTM; \
913 done
914 @for i in ${DIST_DOCS_ARCH_DEP}; do \
915 cp ${RND}/${RELNOTES_LANG}/$$i/${TARGET}/article.txt \
916 ${FD}/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
917 cp ${RND}/${RELNOTES_LANG}/$$i/${TARGET}/article.html \
918 ${FD}/`echo $${i} | tr 'a-z' 'A-Z'`.HTM; \
919 done
920 @cp ${RND}/${RELNOTES_LANG}/readme/docbook.css ${FD}
921 @mv ${FD}/INSTALLATION.TXT ${FD}/INSTALL.TXT
922 @mv ${FD}/INSTALLATION.HTM ${FD}/INSTALL.HTM
923.endif
924 @echo "CD_VERSION = ${BUILDNAME}" > ${FD}/cdrom.inf
925 touch ${.TARGET}
926
927# Build a live filesystem cdrom image
928cdrom.1:
929 @echo "Building CDROM live filesystem image"
930 @mkdir -p ${CD_LIVEFS}
931 @for i in ${DISTRIBUTIONS} ; \
932 do \
933 if [ -d ${RD}/trees/$${i} ] ; then \
934 chflags -R noschg ${RD}/trees/$${i} || true ; \
935 ( cd ${RD}/trees/$${i} && \
936 find . -depth -print | cpio -dumpl ${CD_LIVEFS} ) ; \
937 fi \
938 done
939 @echo "Copy GENERIC kernel to boot area"
940 @cp -Rp ${RD}/kernels/GENERIC/ ${CD_LIVEFS}/boot/kernel
941 @rm -f ${CD_LIVEFS}/.profile
942 @cp ${.CURDIR}/fixit.profile ${CD_LIVEFS}/.profile
943 @ln -sf /rescue ${CD_LIVEFS}/stand
944.if ${TARGET} != "pc98"
945 @echo "Setting up CDROM boot area"
946 @rm -f ${CD_LIVEFS}/boot/loader.conf
947 @cp ${RD}/mfsroot/mfsroot.gz ${CD_LIVEFS}/boot/mfsroot.gz
948 @echo 'mfsroot_load="YES"' > ${CD_LIVEFS}/boot/loader.conf
949 @echo 'mfsroot_type="mfs_root"' >> ${CD_LIVEFS}/boot/loader.conf
950 @echo 'mfsroot_name="/boot/mfsroot"' >> ${CD_LIVEFS}/boot/loader.conf
951.if exists(${RD}/trees/base/boot/device.hints)
952 # Break the link to device.hints so we can modify it
953 @rm -f ${CD_LIVEFS}/boot/device.hints
954 @cp ${RD}/trees/base/boot/device.hints ${CD_LIVEFS}/boot/device.hints
955.if ${TARGET} == "i386" || ${TARGET_ARCH} == "amd64"
956 @echo 'hint.atkbd.0.flags="0x1"' >> ${CD_LIVEFS}/boot/device.hints
957.endif
958.endif
959.endif
960 @echo "CD_VERSION = ${BUILDNAME}" > ${CD_LIVEFS}/cdrom.inf
961 touch ${.TARGET}
962
963# Build disc1 and disc2 cdrom images
964cdrom.2:
965 @echo "Building CDROM disc1 filesystem image"
966 @mkdir -p ${CD_DISC1}/${BUILDNAME}
967.if defined(MAKE_FLOPPIES)
968 @cd ${RD} && find floppies -print | cpio -dumpl ${CD_DISC1}
969.endif
970 @cd ${RD}/dists && find . -print | cpio -dumpl ${CD_DISC1}/${BUILDNAME}
971.if !defined(NODOC)
972 @for i in ${DIST_DOCS_ARCH_INDEP}; do \
973 cp ${RND}/${RELNOTES_LANG}/$$i/article.txt \
974 ${CD_DISC1}/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
975 cp ${RND}/${RELNOTES_LANG}/$$i/article.html \
976 ${CD_DISC1}/`echo $${i} | tr 'a-z' 'A-Z'`.HTM; \
977 done
978 @for i in ${DIST_DOCS_ARCH_DEP}; do \
979 cp ${RND}/${RELNOTES_LANG}/$$i/${TARGET}/article.txt \
980 ${CD_DISC1}/`echo $${i} | tr 'a-z' 'A-Z'`.TXT; \
981 cp ${RND}/${RELNOTES_LANG}/$$i/${TARGET}/article.html \
982 ${CD_DISC1}/`echo $${i} | tr 'a-z' 'A-Z'`.HTM; \
983 done
984 @cp ${RND}/${RELNOTES_LANG}/readme/docbook.css ${CD_DISC1}
985 @mv ${CD_DISC1}/INSTALLATION.TXT ${CD_DISC1}/INSTALL.TXT
986 @mv ${CD_DISC1}/INSTALLATION.HTM ${CD_DISC1}/INSTALL.HTM
987.endif
988.if defined(SEPARATE_LIVEFS)
989 @cp -Rp ${CD_LIVEFS}/boot ${CD_DISC1}
990 @echo "CD_VERSION = ${BUILDNAME}" > ${CD_DISC1}/cdrom.inf
991.endif
992 @echo "CD_VOLUME = 1" >> ${CD_DISC1}/cdrom.inf
993 @echo "Building CDROM disc2 filesystem image"
994 @mkdir -p ${CD_DISC2}
995 @echo "CD_VERSION = ${BUILDNAME}" > ${CD_DISC2}/cdrom.inf
996 @echo "CD_VOLUME = 2" >> ${CD_DISC2}/cdrom.inf
997.if !defined(NODOC)
998 @mkdir -p ${CD_DISC2}/usr/share/doc
999 @for i in `ls ${CD_LIVEFS}/usr/share/doc`; do \
1000 if [ -L ${CD_LIVEFS}/usr/share/doc/$$i -o \
1001 -d /usr/doc/$$i ]; then \
1002 mv ${CD_LIVEFS}/usr/share/doc/$$i \
1003 ${CD_DISC2}/usr/share/doc; \
1004 fi \
1005 done
1006.endif
1007 touch ${.TARGET}
1008
1009#
1010# --==## Setup a suitable cdrom-area ##==--
1011#
1012cdrom.3:
1013.if defined(CD_BOOT)
1014 @echo "Building bootonly CDROM filesystem image"
1015 @mkdir -p ${CD_BOOT}
1016 @cp -Rp ${CD_LIVEFS}/boot ${CD_BOOT}
1017 @echo "CD_VERSION = ${BUILDNAME}" > ${CD_BOOT}/cdrom.inf
1018.if defined(MINIROOT)
1019 @echo "Building bootonly UFS filesystem image"
1020 @mkdir -p ${FD}/miniroot
1021 @sh -e ${DOFS_SH} ${FD}/miniroot/miniroot.ufs \
1022 ${RD} ${MNT} 0 ${CD_BOOT} 8192 auto
1023 @gzip -9v ${FD}/miniroot/miniroot.ufs
1024.endif
1025.endif
1026 touch ${.TARGET}
1027
1028.if make(iso.1)
1029.if defined(CD_PACKAGE_TREE)
1030.if exists(${CD_PACKAGE_TREE}/disc1)
1031CD_DISC1_PKGS= ${CD_PACKAGE_TREE}/disc1
1032.endif
1033.if exists(${CD_PACKAGE_TREE}/disc2)
1034CD_DISC2_PKGS= ${CD_PACKAGE_TREE}/disc2
1035.endif
1036.endif
1037.endif
1038
1039iso.1:
1040.if exists(${.CURDIR}/${TARGET_ARCH}/mkisoimages.sh)
1041 @echo "Creating ISO images..."
1042.if defined(CD_BOOT)
1043 @sh ${.CURDIR}/${TARGET_ARCH}/mkisoimages.sh ${BOOTABLE} \
1044 FreeBSD_bootonly \
1045 ${CD}/${BUILDNAME}-${TARGET}-bootonly.iso ${CD_BOOT}
1046.endif
1047 @sh ${.CURDIR}/${TARGET_ARCH}/mkisoimages.sh ${BOOTABLE} \
1048 FreeBSD_Install \
1049 ${CD}/${BUILDNAME}-${TARGET}-disc1.iso ${CD_DISC1} \
1050 ${CD_DISC1_PKGS}
1051 @sh ${.CURDIR}/${TARGET_ARCH}/mkisoimages.sh \
1052 FreeBSD_Packages \
1053 ${CD}/${BUILDNAME}-${TARGET}-disc2.iso ${CD_DISC2} \
1054 ${CD_DISC2_PKGS}
1055.if defined(SEPARATE_LIVEFS)
1056 @sh ${.CURDIR}/${TARGET_ARCH}/mkisoimages.sh ${BOOTABLE} \
1057 FreeBSD_LiveFS \
1058 ${CD}/${BUILDNAME}-${TARGET}-livefs.iso ${CD_LIVEFS}
1059.endif
1060 @echo "Generating MD5 and SHA256 sums..."
1061 @(cd ${CD} && md5 *.iso > ${BUILDNAME}-${TARGET}-iso.CHECKSUM.MD5)
1062 @(cd ${CD} && sha256 *.iso > ${BUILDNAME}-${TARGET}-iso.CHECKSUM.SHA256)
1063 touch ${.TARGET}
1064.else
1065 @echo "Do not know how to create an ISO for ${TARGET_ARCH}."
1066.endif
1067
1068#
1069# --==## Documentation Project files such as the Handbook and FAQ ##==--
1070#
1071doc.1:
1072 @echo "Making docs..."
1073 @for i in ${DOCPORTS}; do \
1074 cd /usr/ports/$$i && \
1075 env -i FTP_PASSIVE_MODE=$${FTP_PASSIVE_MODE:-no} PATH=$${PATH} \
1076 make all install clean BATCH=yes WITHOUT_X11=yes JADETEX=no \
1077 WITHOUT_PYTHON=yes FORCE_PKG_REGISTER=yes; \
1078 done
1079 @cd /usr/doc && make all install 'FORMATS=html html-split txt' \
1080 INSTALL_COMPRESSED='' DOCDIR=${RD}/trees/base/usr/share/doc \
1081 URLS_ABSOLUTE=YES
1082 touch ${.TARGET}
1083
1084#
1085# --==## RELNOTESng: Next-generation replacements for *.TXT files ##==--
1086#
1087doc.2:
1088 @echo "Making release documentation..."
1089 @cd ${.CURDIR}/doc && make all install clean 'FORMATS=html txt' \
1090 INSTALL_COMPRESSED='' URLS_ABSOLUTE=YES DOCDIR=${RND}
1091 touch ${.TARGET}
1092
1093# Various "subroutine" and other supporting targets.
1094
1095# RD=
1096# SD=
1097# TD=
1098# ARG=
1099doTARBALL:
1100.if !defined(SD)
1101 @echo "SD undefined in doTARBALL" && exit 1
1102.endif
1103.if !defined(TD)
1104 @echo "TD undefined in doTARBALL" && exit 1
1105.endif
1106.if !defined(ARG)
1107 @echo "ARG undefined in doTARBALL" && exit 1
1108.endif
1109 @rm -rf ${RD}/dists/${TD}/${TN}*
1110 @mkdir -p ${RD}/dists/${TD}
1111 @( cd ${SD} && \
1112 tn=`echo ${TN} | tr 'A-Z' 'a-z' | cut -c1-8` && \
1113 echo rolling ${TD}/$$tn tarball &&\
1114 tar --exclude CVS --exclude obj --exclude BOOTMFS -cf - ${ARG} | \
1115 ${ZIPNSPLIT} ${RD}/dists/${TD}/$$tn. && \
1116 sh ${.CURDIR}/scripts/info.sh ${RD}/dists/${TD}/$$tn \
1117 > ${RD}/dists/${TD}/$$tn.inf && \
1118 if [ -f ${.CURDIR}/scripts/$${TD}-install.sh ]; then \
1119 cp -p ${.CURDIR}/scripts/$${TD}-install.sh \
1120 ${RD}/dists/${TD}/install.sh; \
1121 fi && \
1122 if [ "${SD}" != "/usr/src" ]; then \
1123 mtree -c -i -p ${SD}/${ARG} \
1124 -k gname,md5digest,mode,nlink,uname,size,link,type \
1125 > ${RD}/dists/${TD}/$$tn.mtree ; \
1126 else \
1127 true; \
1128 fi; \
1129 ( cd ${RD}/dists/${TD}; \
1130 rm -f CHECKSUM.MD5 CHECKSUM.SHA256; \
1131 md5 * > .CHECKSUM.MD5; \
1132 sha256 * > .CHECKSUM.SHA256; \
1133 mv .CHECKSUM.MD5 CHECKSUM.MD5; \
1134 mv .CHECKSUM.SHA256 CHECKSUM.SHA256) \
1135 )
1136
1137doRELEASE: release.1 release.2 ${DOCREL} release.3 release.4 \
1138 release.5 release.6 release.7 release.8 ${EXTRAS}
1139 @echo "Release done"
1140
1141floppies:
1142 @rm -f release.4 release.8 floppies.[123]
1143 @cd ${.CURDIR} && ${MAKE} release.4 release.8 floppies.1 floppies.2 \
1144 floppies.3
1145 @cd ${RD} && find floppies -print | cpio -dumpl ${FD}
1146
1147installCRUNCH:
1148.if !defined(CRUNCH)
1149 @echo "CRUNCH undefined in installCRUNCH" && exit 1
1150.endif
1151.if !defined(DIR)
1152 @echo "DIR undefined in installCRUNCH" && exit 1
1153.endif
1154.if !defined(ZIP)
1155 @echo "ZIP undefined in installCRUNCH" && exit 1
1156.endif
1157 @if ${ZIP} ; then \
1158 gzip -9 < ${RD}/crunch/${CRUNCH} > ${DIR}/${CRUNCH}_crunch ; \
1159 else \
1160 ln -f ${RD}/crunch/${CRUNCH} ${DIR}/${CRUNCH}_crunch ; \
1161 fi
1162 @chmod 555 ${DIR}/${CRUNCH}_crunch
1163 @if [ -f ${.CURDIR}/${TARGET}/${CRUNCH}_crunch.conf ] ; then \
1164 for i in `crunchgen -l ${.CURDIR}/${TARGET}/${CRUNCH}_crunch.conf` ; do \
1165 ln -f ${DIR}/${CRUNCH}_crunch ${DIR}/$$i ; \
1166 done \
1167 else \
1168 for i in `crunchgen -l ${.CURDIR}/${CRUNCH}_crunch.conf` ; do \
1169 ln -f ${DIR}/${CRUNCH}_crunch ${DIR}/$$i ; \
1170 done \
1171 fi
1172
1173#
1174# --==## Build a floppy set for a splitfs file ##==--
1175#
1176# FLOPPYBASE - basename of floppy image files
1177# FLOPPYDESC - description of floppy set
1178# SPLITFILE - filename of the file to split
1179# FDSIZE - if specified and "small", small floppy is created
1180
1181.if make(makeFloppySet)
1182SPLITDIR= ${RD}/floppyset/${FLOPPYBASE}
1183.if defined(FDSIZE) && ${FDSIZE} == "SMALL"
1184FLPSPLITSIZE= ${SMALLFLOPPYSPLITSIZE}
1185FLPSIZE= ${SMALLFLOPPYSIZE}
1186FLPLABEL= ${SMALLFLOPPYLABEL}
1187.else
1188FLPSPLITSIZE= ${FLOPPYSPLITSIZE}
1189FLPSIZE= ${FLOPPYSIZE}
1190FLPLABEL= ${FLOPPYLABEL}
1191.endif
1192.endif
1193
1194makeFloppySet:
1195.if !defined(FLOPPYBASE)
1196 @echo "FLOPPYBASE undefined in ${.TARGET}" && exit 1
1197.endif
1198.if !defined(FLOPPYDESC)
1199 @echo "FLOPPYDESC undefined in ${.TARGET}" && exit 1
1200.endif
1201.if !defined(SPLITFILE)
1202 @echo "SPLITFILE undefined in ${.TARGET}" && exit 1
1203.endif
1204 sh ${.CURDIR}/scripts/split-file.sh ${SPLITFILE} \
1205 ${RD}/floppyset/${FLOPPYBASE} ${FLPSPLITSIZE} "${FLOPPYDESC}"
1206 ( splitfile=${SPLITDIR}/`basename ${SPLITFILE}`.split ; \
1207 lines=`cat $${splitfile} | wc -l`; \
1208 lines=$$(($$lines - 1)) ; \
1209 for line in `jot $$lines`; do \
1210 file=`head -n $$(($${line} + 1)) $${splitfile} | tail -1 | cut -f 1 -d ' '` ; \
1211 sh -e ${DOFS_SH} ${RD}/floppies/${FLOPPYBASE}$${line}.flp \
1212 ${RD} ${MNT} ${FLPSIZE} ${SPLITDIR}/$${file} \
1213 ${BOOTINODE} ${FLPLABEL}; \
1214 done )
1215
1216#
1217# --==## Build a boot floppy ##==--
1218#
1219# FSIMAGE - base floppy image name
1220# FDSIZE - if specified and "small", small floppy is created
1221# KERNFILE - path to kernel split file
1222# MFSROOTFILE - path to mfsroot split file
1223
1224.if make(buildBootFloppy)
1225IMAGEDIR= ${RD}/image.${FSIMAGE}
1226BOOTDIR= ${RD}/trees/base/boot
1227HINTSFILE= ${BOOTDIR}/device.hints
1228ACPI_KO= ${BOOTDIR}/kernel/acpi.ko
1229IMAGEFILE= ${RD}/floppies/${FSIMAGE}.flp
1230.if defined(FDSIZE) && ${FDSIZE} == "SMALL"
1231FLPSIZE= ${SMALLFLOPPYSIZE}
1232FLPLABEL= ${SMALLFLOPPYLABEL}
1233.else
1234FLPSIZE= ${FLOPPYSIZE}
1235FLPLABEL= ${FLOPPYLABEL}
1236.endif
1237.endif
1238
1239buildBootFloppy:
1240.if !defined(FSIMAGE)
1241 @echo "FSIMAGE undefined in ${.TARGET}" && exit 1
1242.endif
1243.if !defined(KERNFILE)
1244 @echo "KERNFILE undefined in ${.TARGET}" && exit 1
1245.endif
1246.if !defined(MFSROOTFILE)
1247 @echo "MFSROOTFILE undefined in ${.TARGET}" && exit 1
1248.endif
1249 @echo "Running ${.TARGET} for ${FSIMAGE}"
1250 @rm -rf ${IMAGEDIR}
1251 @mkdir ${IMAGEDIR}
1252 @echo "Setting up /boot directory for ${FSIMAGE} floppy"
1253 @mkdir -p ${IMAGEDIR}/boot
1254.if ${TARGET} == "i386"
1255 @${WMAKEENV} kgzip -v -l ${RD}/trees/base/usr/lib/kgzldr.o -o \
1256 ${IMAGEDIR}/boot/loader ${BOOTDIR}/loader
1257.else
1258 @cp ${BOOTDIR}/loader ${IMAGEDIR}/boot
1259.endif
1260 @cp -Rp ${BOOTDIR}/*.4th ${BOOTDIR}/defaults ${BOOTDIR}/loader.help \
1261 ${BOOTDIR}/loader.rc ${IMAGEDIR}/boot
1262.if exists(${HINTSFILE})
1263 @cp ${HINTSFILE} ${IMAGEDIR}/boot/device.hints
1264.if ${TARGET} == "i386" || ${TARGET_ARCH} == "amd64"
1265 @echo 'hint.atkbd.0.flags="0x1"' >> ${IMAGEDIR}/boot/device.hints
1266.endif
1267 @gzip -9n ${IMAGEDIR}/boot/device.hints
1268.endif
1269 @gzip -9n ${IMAGEDIR}/boot/*.4th ${IMAGEDIR}/boot/loader.help \
1270 ${IMAGEDIR}/boot/defaults/loader.conf
1271 @echo 'bootfile="/kernel"' > ${IMAGEDIR}/boot/loader.conf
1272.if exists(${ACPI_KO})
1273 @gzip -9nc ${ACPI_KO} > ${IMAGEDIR}/acpi.ko.gz
1274 @echo 'acpi_load="YES"' >> ${IMAGEDIR}/boot/loader.conf
1275 @echo 'acpi_name="/acpi.ko"' >> ${IMAGEDIR}/boot/loader.conf
1276 @echo 'acpi_before="read -p \"Insert boot floppy and press Enter\""' >> ${IMAGEDIR}/boot/loader.conf
1277.endif
1278 @echo 'mfsroot_load="YES"' >> ${IMAGEDIR}/boot/loader.conf
1279 @echo 'mfsroot_type="mfs_root"' >> ${IMAGEDIR}/boot/loader.conf
1280 @echo 'mfsroot_name="/mfsroot"' >> ${IMAGEDIR}/boot/loader.conf
1281.if !exists(${ACPI_KO})
1282 @echo 'mfsroot_before="read -p \"Insert boot floppy and press Enter\""' >> ${IMAGEDIR}/boot/loader.conf
1283.endif
1284.if defined(SPLIT_MFSROOT)
1285 @echo 'mfsroot_after="read -p \"Insert boot floppy and press Enter\""' >> ${IMAGEDIR}/boot/loader.conf
1286.endif
1287.if ${TARGET_ARCH} == "i386" && ${AUTO_KEYBOARD_DETECT}
1288 @echo "-P" >> ${IMAGEDIR}/boot.config
1289.endif
1290 @rm -f ${IMAGEFILE}
1291 @cp ${KERNFILE} ${MFSROOTFILE} ${IMAGEDIR}
1292 sh -e ${DOFS_SH} ${IMAGEFILE} ${RD} ${MNT} ${FLPSIZE} ${IMAGEDIR} \
1293 ${BOOTINODE} ${FLPLABEL}
1294 @echo "Created ${RD}/floppies/${FSIMAGE}.flp"
1295
1296.if make(package-split)
1297# Targets related to making a package split
1298#
1299# PKG_COPY instructs the script to copy the actual package files rather than
1300# make hard links
1301# PKG_TREE is the path to the package tree to be split
1302# PKG_DEST is the path to the destination tree to create the split in
1303# PKG_VERBOSE asks for verbose output of the layout process
1304# PKG_INDEX is the path to the INDEX file. By default ${PKG_TREE}/INDEX.
1305
1306.if defined(PKG_COPY)
1307PKG_DO_COPY= cp
1308.else
1309PKG_DO_COPY= ln
1310.endif
1311PKG_WRKIDX= ${PKG_DEST}/INDEX.master
1312PKG_ENV?=
1313.if defined(TARGET_ARCH)
1314PKG_ENV+= PKG_ARCH=${TARGET_ARCH}
1315.endif
1316.if defined(PKG_VERBOSE)
1317PKG_ENV+= PKG_VERBOSE=1
1318.endif
1319PKG_INDEX?= ${PKG_TREE}/INDEX
1320
1321package-split:
1322.if !defined(PKG_TREE)
1323 @echo "PKG_TREE must be defined" && exit 1
1324.endif
1325.if !defined(PKG_DEST)
1326 @echo "PKG_DEST must be defined" && exit 1
1327.endif
1328 @env ${PKG_ENV} python ${.CURDIR}/scripts/package-split.py \
1329 ${PKG_INDEX} ${PKG_WRKIDX}
1330 @env ${PKG_ENV} sh ${.CURDIR}/scripts/package-trees.sh ${PKG_DO_COPY} \
1331 ${PKG_WRKIDX} ${PKG_TREE} ${PKG_DEST}
1332.endif
1333
1334.include <bsd.obj.mk>